/*!
 * Copyright (c) 2012 - 2019, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"]);
})(this, function(Bokeh) {
  var define;
  return (function(modules, entry, aliases, externals) {
    if (Bokeh != null) {
      return Bokeh.register_plugin(modules, entry, aliases, externals);
    } else {
      throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
    }
  })
({
"aa4f566620": function _(r,e,t){var n=(this&&this.__importStar||function(r){if(r&&r.__esModule)return r;var e={};if(null!=r)for(var t in r)Object.hasOwnProperty.call(r,t)&&(e[t]=r[t]);return e.default=r,e})(r("4d02676c49"));t.Panel=n,r("@bokehjs/base").register_models(n)},
"4d02676c49": function _(a,e,r){var o=a("ff4b91e885");r.AcePlot=o.AcePlot;var t=a("12e90a1b7e");r.Audio=t.Audio;var c=a("cf3b018c7a");r.DeckGLPlot=c.DeckGLPlot;var d=a("70a2bb70ef");r.HTML=d.HTML;var v=a("dac8d750fa");r.JSON=v.JSON;var P=a("c81021c8fd");r.KaTeX=P.KaTeX;var b=a("a93ded647d");r.MathJax=b.MathJax;var l=a("98100899bc");r.Player=l.Player;var f=a("d46f026c83");r.PlotlyPlot=f.PlotlyPlot;var i=a("d9b3a262de");r.Progress=i.Progress;var n=a("4b4afba86a");r.State=n.State;var S=a("14b669e6fc");r.VegaPlot=S.VegaPlot;var V=a("71a2bbec38");r.Video=V.Video;var s=a("76bc93d621");r.VideoStream=s.VideoStream,function(a){for(var e in a)r.hasOwnProperty(e)||(r[e]=a[e])}(a("63070bc9ce"))},
"ff4b91e885": function _(t,e,o){var i,n=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/models/layouts/html_box"),a=t("@bokehjs/core/dom");var c=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._ace=window.ace,this._container=a.div({id:"_"+Math.random().toString(36).substr(2,9),style:{width:"100%",height:"100%"}})},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.code.change,function(){return e._update_code_from_model()}),this.connect(this.model.properties.theme.change,function(){return e._update_theme()}),this.connect(this.model.properties.language.change,function(){return e._update_language()}),this.connect(this.model.properties.annotations.change,function(){return e._add_annotations()}),this.connect(this.model.properties.readonly.change,function(){e._editor.setReadOnly(e.model.readonly)})},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this._container!==this.el.childNodes[0]&&this.el.appendChild(this._container),this._container.textContent=this.model.code,this._editor=this._ace.edit(this._container.id),this._editor.setTheme("ace/theme/"+this.model.theme),this._editor.session.setMode("ace/mode/"+this.model.language),this._editor.setReadOnly(this.model.readonly),this._langTools=this._ace.require("ace/ext/language_tools"),this._editor.setOptions({enableBasicAutocompletion:!0,enableSnippets:!0,fontFamily:"monospace"}),this._editor.on("change",function(){return e._update_code_from_editor()})},e.prototype._update_code_from_model=function(){this._editor&&this._editor.getValue()!=this.model.code&&this._editor.setValue(this.model.code)},e.prototype._update_code_from_editor=function(){this._editor.getValue()!=this.model.code&&(this.model.code=this._editor.getValue())},e.prototype._update_theme=function(){this._editor.setTheme("ace/theme/"+this.model.theme)},e.prototype._update_language=function(){this._editor.session.setMode("ace/mode/"+this.model.language)},e.prototype._add_annotations=function(){this._editor.session.setAnnotations(this.model.annotations)},e.prototype.after_layout=function(){t.prototype.after_layout.call(this),this._editor.resize()},e.__name__="AcePlotView",e}(t("ec60963462").PanelHTMLBoxView);o.AcePlotView=c;var h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_AcePlot=function(){this.prototype.default_view=c,this.define({code:[r.String],language:[r.String,"python"],theme:[r.String,"chrome"],annotations:[r.Array,[]],readonly:[r.Boolean,!1]}),this.override({height:300,width:300})},e.__name__="AcePlot",e.__module__="panel.models.ace",e}(s.HTMLBox);o.AcePlot=h,h.init_AcePlot()},
"ec60963462": function _(e,t,i){var o,n=this&&this.__extends||(o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i])})(e,t)},function(e,t){function i(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)}),s=e("@bokehjs/core/layout/layoutable"),h=e("@bokehjs/core/layout/types"),r=e("@bokehjs/core/dom"),a=e("@bokehjs/models/widgets/markup"),_=e("@bokehjs/models/layouts/html_box");function c(e,t){var i=null!=t.width?"fixed":"fit",o=null!=t.height?"fixed":"fit",n=t.sizing_mode;if(null!=n)if("fixed"==n)i=o="fixed";else if("stretch_both"==n)i=o="max";else if("stretch_width"==n)i="max";else if("stretch_height"==n)o="max";else switch(n){case"scale_width":i="max",o="min";break;case"scale_height":i="min",o="max";break;case"scale_both":i="max",o="max";break;default:throw new Error("unreachable")}"fixed"==i&&t.width?e.style.width=t.width+"px":"max"==i&&(e.style.width="100%"),"fixed"==o&&t.height?e.style.height=t.height+"px":"max"==o&&(e.style.height="100%")}i.set_size=c;var l=function(e){function t(t,i,o){var n=e.call(this)||this;return n.el=t,n.sizing_mode=i,n.changed=o,n._cache={},n._cache_count={},n}return n(t,e),t.prototype._measure=function(e){var t=this,i=[e.width,e.height,this.sizing_mode].toString(),o=this.changed&&"fixed"!=this.sizing_mode&&null!=this.sizing_mode?1:0;if(i in this._cache&&this._cache_count[i]>=o)return this._cache_count[i]=this._cache_count[i]+1,this._cache[i];var n=new h.Sizeable(e).bounded_to(this.sizing.size),s=r.sized(this.el,n,function(){var e=new h.Sizeable(r.content_size(t.el)),i=r.extents(t.el),o=i.border,n=i.padding;return e.grow_by(o).grow_by(n).map(Math.ceil)});return this._cache[i]=s,this._cache_count[i]=0,s},t.__name__="CachedVariadicBox",t}(s.Layoutable);i.CachedVariadicBox=l;var d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype._update_layout=function(){var e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())},t.prototype.render=function(){e.prototype.render.call(this),c(this.markup_el,this.model)},t.__name__="PanelMarkupView",t}(a.MarkupView);i.PanelMarkupView=d;var u=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype._update_layout=function(){var e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())},t.prototype.render=function(){e.prototype.render.call(this),c(this.el,this.model)},t.__name__="PanelHTMLBoxView",t}(_.HTMLBoxView);i.PanelHTMLBoxView=u},
"12e90a1b7e": function _(t,e,o){var i,n=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),u=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),l=t("@bokehjs/models/layouts/html_box"),s=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._blocked=!1,this._setting=!1,this._time=Date.now()},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.loop.change,function(){return e.set_loop()}),this.connect(this.model.properties.paused.change,function(){return e.set_paused()}),this.connect(this.model.properties.time.change,function(){return e.set_time()}),this.connect(this.model.properties.value.change,function(){return e.set_value()}),this.connect(this.model.properties.volume.change,function(){return e.set_volume()})},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this.audioEl=document.createElement("audio"),this.audioEl.controls=!0,this.audioEl.src=this.model.value,this.audioEl.currentTime=this.model.time,this.audioEl.loop=this.model.loop,null!=this.model.volume?this.audioEl.volume=this.model.volume/100:this.model.volume=100*this.audioEl.volume,this.audioEl.onpause=function(){return e.model.paused=!0},this.audioEl.onplay=function(){return e.model.paused=!1},this.audioEl.ontimeupdate=function(){return e.update_time(e)},this.audioEl.onvolumechange=function(){return e.update_volume(e)},this.el.appendChild(this.audioEl),this.model.paused||this.audioEl.play()},e.prototype.update_time=function(t){t._setting?t._setting=!1:Date.now()-t._time<t.model.throttle||(t._blocked=!0,t.model.time=t.audioEl.currentTime,t._time=Date.now())},e.prototype.update_volume=function(t){t._setting?t._setting=!1:(t._blocked=!0,t.model.volume=100*t.audioEl.volume)},e.prototype.set_loop=function(){this.audioEl.loop=this.model.loop},e.prototype.set_paused=function(){!this.audioEl.paused&&this.model.paused&&this.audioEl.pause(),this.audioEl.paused&&!this.model.paused&&this.audioEl.play()},e.prototype.set_volume=function(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.audioEl.volume=this.model.volume/100))},e.prototype.set_time=function(){this._blocked?this._blocked=!1:(this._setting=!0,this.audioEl.currentTime=this.model.time)},e.prototype.set_value=function(){this.audioEl.src=this.model.value},e.__name__="AudioView",e}(t("ec60963462").PanelHTMLBoxView);o.AudioView=s;var r=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_Audio=function(){this.prototype.default_view=s,this.define({loop:[u.Boolean,!1],paused:[u.Boolean,!0],time:[u.Number,0],throttle:[u.Number,250],value:[u.Any,""],volume:[u.Number,null]})},e.__name__="Audio",e.__module__="panel.models.widgets",e}(l.HTMLBox);o.Audio=r,r.init_Audio()},
"cf3b018c7a": function _(t,e,o){var n,i=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),r=this&&this.__assign||function(){return(r=Object.assign||function(t){for(var e,o=1,n=arguments.length;o<n;o++)for(var i in e=arguments[o])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t}).apply(this,arguments)},a=this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e},s=this&&this.__importDefault||function(t){return t&&t.__esModule?t:{default:t}},c=t("@bokehjs/core/dom"),l=a(t("@bokehjs/core/properties")),p=t("@bokehjs/models/layouts/html_box"),_=t("ec60963462"),u=t("27d3545a25"),h=s(t("093eb75864")),d=window.deck,f=window.mapboxgl,v=window.loaders;function y(){for(var t={},e=0,o=Object.keys(d).filter(function(t){return t.charAt(0)===t.charAt(0).toUpperCase()});e<o.length;e++){var n=o[e];t[n]=d[n]}return t}var m=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this);var o=this.model.properties,n=o.data,i=o.mapbox_api_key,r=o.tooltip,a=o.layers,s=o.initialViewState,c=o.data_sources;this.on_change([i,r],function(){return e.render()}),this.on_change([n,s],function(){return e.updateDeck()}),this.on_change([a],function(){return e._update_layers()}),this.on_change([c],function(){return e._connect_sources(!0)}),this._layer_map={},this._connected=[],this._connect_sources()},e.prototype._update_layers=function(){this._layer_map={},this._update_data(!0)},e.prototype._connect_sources=function(t){var e=this;void 0===t&&(t=!1);for(var o=0,n=this.model.data_sources;o<n.length;o++){var i=n[o];this._connected.indexOf(i)<0&&(this.connect(i.properties.data.change,function(){return e._update_data(!0)}),this._connected.push(i))}this._update_data(t)},e.prototype.initialize=function(){if(t.prototype.initialize.call(this),d.JSONConverter){var e=v.CSVLoader,o=v.Tile3DLoader;v.registerLoaders([o,e]);var n={classes:y(),enumerations:{COORDINATE_SYSTEM:d.COORDINATE_SYSTEM,GL:h.default},constants:{Tile3DLoader:o}};this.jsonConverter=new d.JSONConverter({configuration:n})}},e.prototype._update_data=function(t){void 0===t&&(t=!0);for(var e=0,o=0,n=this.model.layers;o<n.length;o++){var i=n[o],r=void 0;if((e+=1)-1 in this._layer_map)r=this.model.data_sources[this._layer_map[e-1]];else{if("number"!=typeof i.data)continue;this._layer_map[e-1]=i.data,r=this.model.data_sources[i.data]}for(var a=[],s=r.columns(),c=0;c<r.data[s[0]].length;c++){for(var l={},p=0,_=s;p<_.length;p++){var u=_[p],h=r._shapes[u];void 0!==h&&h.length>1&&"number"==typeof h[0]?l[u]=r.data[u].slice(c*h[1],c*h[1]+h[1]):l[u]=r.data[u][c]}a.push(l)}i.data=a}t&&this.updateDeck()},e.prototype._on_click_event=function(t){var e={coordinate:t.coordinate,lngLat:t.lngLat,index:t.index};this.model.clickState=e},e.prototype._on_hover_event=function(t){var e={coordinate:t.coordinate,lngLat:t.lngLat,index:t.index};this.model.hoverState=e},e.prototype._on_viewState_event=function(t){this.model.viewState=t.viewState},e.prototype.getData=function(){var t=this;return r(r({},this.model.data),{layers:this.model.layers,initialViewState:this.model.initialViewState,onViewStateChange:function(e){return t._on_viewState_event(e)},onClick:function(e){return t._on_click_event(e)},onHover:function(e){return t._on_hover_event(e)}})},e.prototype.updateDeck=function(){if(this.deckGL){var t=this.getData();if(d.updateDeck)d.updateDeck(t,this.deckGL);else{var e=this.jsonConverter.convert(t);this.deckGL.setProps(e)}}else this.render()},e.prototype.createDeck=function(t){var e,o=t.mapboxApiKey,n=t.container,i=t.jsonInput,a=t.tooltip;try{var s=this.jsonConverter.convert(i),c=u.makeTooltip(a);e=new d.DeckGL(r(r({},s),{map:f,mapboxApiAccessToken:o,container:n,getTooltip:c}))}catch(t){console.error(t)}return e},e.prototype.render=function(){t.prototype.render.call(this);var e=c.div({class:"deckgl"});_.set_size(e,this.model);var o=this.model.mapbox_api_key,n=this.model.tooltip,i=this.getData();d.createDeck?this.deckGL=d.createDeck({mapboxApiKey:o,container:e,jsonInput:i,tooltip:n}):this.deckGL=this.createDeck({mapboxApiKey:o,container:e,jsonInput:i,tooltip:n}),this.el.appendChild(e)},e.__name__="DeckGLPlotView",e}(_.PanelHTMLBoxView);o.DeckGLPlotView=m;var k=function(t){function e(e){return t.call(this,e)||this}return i(e,t),e.init_DeckGLPlot=function(){this.prototype.default_view=m,this.define({data:[l.Any],data_sources:[l.Array,[]],clickState:[l.Any],hoverState:[l.Any],initialViewState:[l.Any],layers:[l.Array,[]],mapbox_api_key:[l.String],tooltip:[l.Any],viewState:[l.Any]}),this.override({height:400,width:600})},e.__name__="DeckGLPlot",e.__module__="panel.models.deckgl",e}(p.HTMLBox);o.DeckGLPlot=k,k.init_DeckGLPlot()},
"27d3545a25": function _(e,t,n){var i,r,l={fontFamily:'"Helvetica Neue", Helvetica, Arial, sans-serif',display:"flex",flex:"wrap",maxWidth:"500px",flexDirection:"column",zIndex:2};function a(){return document.createElement("div")}function o(e){if(!e.picked)return null;if(e.object===i)return r;var t={html:c(e.object),style:l};return r=t,i=e.object,t}n.getTooltipDefault=o;var s=new Set(["position","index"]);function c(e){var t=a();for(var n in e)if(!s.has(n)){var i=a();i.className="header",i.textContent=n;var r=a();r.className="value",r.textContent=u(e[n]);var l=a();f(l,i,r),l.appendChild(i),l.appendChild(r),t.appendChild(l)}return t.innerHTML}function f(e,t,n){Object.assign(t.style,{fontWeight:700,marginRight:"10px",flex:"1 1 0%"}),Object.assign(n.style,{flex:"none",maxWidth:"250px",overflow:"hidden",whiteSpace:"nowrap",textOverflow:"ellipsis"}),Object.assign(e.style,{display:"flex",flexDirection:"row",justifyContent:"space-between",alignItems:"stretch"})}function u(e){var t;if(Array.isArray(e)&&e.length>4)t="Array<"+e.length+">";else if("string"==typeof e)t=e;else if("number"==typeof e)t=String(e);else try{t=JSON.stringify(e)}catch(e){t="<Non-Serializable Object>"}return t.length>50&&(t=t.slice(0,50)),t}function p(e,t){var n=e;for(var i in t)n=n.replace("{"+i+"}",t[i]);return n}n.tabularize=c,n.toText=u,n.substituteIn=p,n.makeTooltip=function(e){return e?e.html||e.text?function(t){if(!t.picked)return null;var n={style:e.style||l};return e.html?n.html=p(e.html,t.object):n.text=p(e.text,t.object),n}:o:null}},
"093eb75864": function _(E,_,R){_.exports={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,FUNC_ADD:32774,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,BLEND_COLOR:32773,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,VENDOR:7936,RENDERER:7937,VERSION:7938,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,BROWSER_DEFAULT_WEBGL:37444,STATIC_DRAW:35044,STREAM_DRAW:35040,DYNAMIC_DRAW:35048,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,CULL_FACE:2884,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,BLEND:3042,DEPTH_TEST:2929,DITHER:3024,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,SCISSOR_TEST:3089,STENCIL_TEST:2960,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CONTEXT_LOST_WEBGL:37442,CW:2304,CCW:2305,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DOUBLE:5130,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,COMPILE_STATUS:35713,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_ATTRIBUTES:35721,ACTIVE_UNIFORMS:35718,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,ALWAYS:519,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,GEQUAL:518,NOTEQUAL:517,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,TEXTURE_WIDTH:4096,TEXTURE_HEIGHT:4097,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,MAX_3D_TEXTURE_SIZE:32883,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,MAX_TEXTURE_LOD_BIAS:34045,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,RASTERIZER_DISCARD:35977,VERTEX_ARRAY_BINDING:34229,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,MAX_ELEMENT_INDEX:36203,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,RGB9_E5:35901,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,RGB10_A2UI:36975,TEXTURE_IMMUTABLE_FORMAT:37167,TEXTURE_IMMUTABLE_LEVELS:33503,UNSIGNED_INT_2_10_10_10_REV:33640,UNSIGNED_INT_10F_11F_11F_REV:35899,UNSIGNED_INT_5_9_9_9_REV:35902,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,UNSIGNED_INT_24_8:34042,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,INT_2_10_10_10_REV:36255,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,MAX_SAMPLES:36183,SAMPLER_BINDING:35097,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,UNSIGNED_NORMALIZED:35863,SIGNED_NORMALIZED:36764,VERTEX_ATTRIB_ARRAY_INTEGER:35069,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,DEPTH24_STENCIL8:35056,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,COLOR:6144,DEPTH:6145,STENCIL:6146,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,INVALID_INDEX:4294967295,TIMEOUT_IGNORED:-1,MAX_CLIENT_WAIT_TIMEOUT_WEBGL:37447,VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE:35070,UNMASKED_VENDOR_WEBGL:37445,UNMASKED_RENDERER_WEBGL:37446,MAX_TEXTURE_MAX_ANISOTROPY_EXT:34047,TEXTURE_MAX_ANISOTROPY_EXT:34046,COMPRESSED_RGB_S3TC_DXT1_EXT:33776,COMPRESSED_RGBA_S3TC_DXT1_EXT:33777,COMPRESSED_RGBA_S3TC_DXT3_EXT:33778,COMPRESSED_RGBA_S3TC_DXT5_EXT:33779,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_RGBA8_ETC2_EAC:37493,COMPRESSED_SRGB8_ETC2:37494,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37495,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37496,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37497,COMPRESSED_RGB_PVRTC_4BPPV1_IMG:35840,COMPRESSED_RGBA_PVRTC_4BPPV1_IMG:35842,COMPRESSED_RGB_PVRTC_2BPPV1_IMG:35841,COMPRESSED_RGBA_PVRTC_2BPPV1_IMG:35843,COMPRESSED_RGB_ETC1_WEBGL:36196,COMPRESSED_RGB_ATC_WEBGL:35986,COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL:35986,COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL:34798,UNSIGNED_INT_24_8_WEBGL:34042,HALF_FLOAT_OES:36193,RGBA32F_EXT:34836,RGB32F_EXT:34837,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT:33297,UNSIGNED_NORMALIZED_EXT:35863,MIN_EXT:32775,MAX_EXT:32776,SRGB_EXT:35904,SRGB_ALPHA_EXT:35906,SRGB8_ALPHA8_EXT:35907,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT:33296,FRAGMENT_SHADER_DERIVATIVE_HINT_OES:35723,COLOR_ATTACHMENT0_WEBGL:36064,COLOR_ATTACHMENT1_WEBGL:36065,COLOR_ATTACHMENT2_WEBGL:36066,COLOR_ATTACHMENT3_WEBGL:36067,COLOR_ATTACHMENT4_WEBGL:36068,COLOR_ATTACHMENT5_WEBGL:36069,COLOR_ATTACHMENT6_WEBGL:36070,COLOR_ATTACHMENT7_WEBGL:36071,COLOR_ATTACHMENT8_WEBGL:36072,COLOR_ATTACHMENT9_WEBGL:36073,COLOR_ATTACHMENT10_WEBGL:36074,COLOR_ATTACHMENT11_WEBGL:36075,COLOR_ATTACHMENT12_WEBGL:36076,COLOR_ATTACHMENT13_WEBGL:36077,COLOR_ATTACHMENT14_WEBGL:36078,COLOR_ATTACHMENT15_WEBGL:36079,DRAW_BUFFER0_WEBGL:34853,DRAW_BUFFER1_WEBGL:34854,DRAW_BUFFER2_WEBGL:34855,DRAW_BUFFER3_WEBGL:34856,DRAW_BUFFER4_WEBGL:34857,DRAW_BUFFER5_WEBGL:34858,DRAW_BUFFER6_WEBGL:34859,DRAW_BUFFER7_WEBGL:34860,DRAW_BUFFER8_WEBGL:34861,DRAW_BUFFER9_WEBGL:34862,DRAW_BUFFER10_WEBGL:34863,DRAW_BUFFER11_WEBGL:34864,DRAW_BUFFER12_WEBGL:34865,DRAW_BUFFER13_WEBGL:34866,DRAW_BUFFER14_WEBGL:34867,DRAW_BUFFER15_WEBGL:34868,MAX_COLOR_ATTACHMENTS_WEBGL:36063,MAX_DRAW_BUFFERS_WEBGL:34852,VERTEX_ARRAY_BINDING_OES:34229,QUERY_COUNTER_BITS_EXT:34916,CURRENT_QUERY_EXT:34917,QUERY_RESULT_EXT:34918,QUERY_RESULT_AVAILABLE_EXT:34919,TIME_ELAPSED_EXT:35007,TIMESTAMP_EXT:36392,GPU_DISJOINT_EXT:36795}},
"70a2bb70ef": function _(t,e,r){var n,o=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(t,e)},function(t,e){function r(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}),i=t("@bokehjs/models/widgets/markup");var a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.render=function(){t.prototype.render.call(this);var e,r=(e=this.model.text,(new DOMParser).parseFromString(e,"text/html").documentElement.textContent)||this.model.text;r?(this.markup_el.innerHTML=r,Array.from(this.markup_el.querySelectorAll("script")).forEach(function(t){var e=document.createElement("script");Array.from(t.attributes).forEach(function(t){return e.setAttribute(t.name,t.value)}),e.appendChild(document.createTextNode(t.innerHTML)),t.parentNode&&t.parentNode.replaceChild(e,t)})):this.markup_el.innerHTML=""},e.__name__="HTMLView",e}(t("ec60963462").PanelMarkupView);r.HTMLView=a;var u=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_HTML=function(){this.prototype.default_view=a},e.__name__="HTML",e.__module__="panel.models.markup",e}(i.Markup);r.HTML=u,u.init_HTML()},
"dac8d750fa": function _(e,t,r){var n,o=this&&this.__extends||(n=function(e,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)},function(e,t){function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),i=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)Object.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t.default=e,t},a=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}},u=i(e("@bokehjs/core/properties")),s=e("@bokehjs/models/widgets/markup"),p=a(e("cb07e54f5a")),l=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),t.prototype.render=function(){e.prototype.render.call(this);var t,r=this.model.text.replace(/(\r\n|\n|\r)/gm,"").replace("'",'"');try{t=window.JSON.parse(r)}catch(e){return void(this.markup_el.innerHTML="<b>Invalid JSON:</b> "+e.toString())}var n={hoverPreviewEnabled:this.model.hover_preview,theme:this.model.theme},o=new p.default(t,this.model.depth,n).render(),i="border-radius: 5px; padding: 10px;";"dark"==this.model.theme?o.style.cssText="background-color: rgb(30, 30, 30);"+i:o.style.cssText=i,this.markup_el.append(o)},t.__name__="JSONView",t}(e("ec60963462").PanelMarkupView);r.JSONView=l;var _=["dark","light"],h=function(e){function t(t){return e.call(this,t)||this}return o(t,e),t.init_JSON=function(){this.prototype.default_view=l,this.define({depth:[u.Number,1],hover_preview:[u.Boolean,!1],theme:[u.Enum(_),"dark"]})},t.__name__="JSON",t.__module__="panel.models.markup",t}(s.Markup);r.JSON=h,h.init_JSON()},
"cb07e54f5a": function _(t,e,r){function n(t){return null===t?"null":typeof t}function o(t){return!!t&&"object"==typeof t}function i(t){if(void 0===t)return"";if(null===t)return"Object";if("object"==typeof t&&!t.constructor)return"Object";var e=/function ([^(]*)/.exec(t.constructor.toString());return e&&e.length>1?e[1]:""}function s(t,e,r){return"null"===t||"undefined"===t?t:("string"!==t&&"stringifiable"!==t||(r='"'+function(t){return t.replace(/"/g,'\\"')}(r)+'"'),"function"===t?e.toString().replace(/[\r\n]/g,"").replace(/\{.*\}/,"")+"{…}":r)}function a(t){var e="";return o(t)?(e=i(t),Array.isArray(t)&&(e+="["+t.length+"]")):e=s(n(t),t,t),e}function f(t){return"json-formatter-"+t}function m(t,e,r){var n=document.createElement(t);return e&&n.classList.add(f(e)),void 0!==r&&(r instanceof Node?n.appendChild(r):n.appendChild(document.createTextNode(String(r)))),n}!function(t){if(t&&"undefined"!=typeof window){var e=document.createElement("style");e.setAttribute("media","screen"),e.innerHTML=t,document.head.appendChild(e)}}('.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-row,\n.json-formatter-row a,\n.json-formatter-row a:hover {\n  color: black;\n  text-decoration: none;\n}\n.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-row .json-formatter-string,\n.json-formatter-row .json-formatter-stringifiable {\n  color: green;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-row .json-formatter-number {\n  color: blue;\n}\n.json-formatter-row .json-formatter-boolean {\n  color: red;\n}\n.json-formatter-row .json-formatter-null {\n  color: #855A00;\n}\n.json-formatter-row .json-formatter-undefined {\n  color: #ca0b69;\n}\n.json-formatter-row .json-formatter-function {\n  color: #FF20ED;\n}\n.json-formatter-row .json-formatter-date {\n  background-color: rgba(0, 0, 0, 0.05);\n}\n.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: blue;\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-bracket {\n  color: blue;\n}\n.json-formatter-row .json-formatter-key {\n  color: #00008B;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "►";\n}\n.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n.json-formatter-dark.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-dark.json-formatter-row,\n.json-formatter-dark.json-formatter-row a,\n.json-formatter-dark.json-formatter-row a:hover {\n  color: white;\n  text-decoration: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-string,\n.json-formatter-dark.json-formatter-row .json-formatter-stringifiable {\n  color: #31F031;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-number {\n  color: #66C2FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-boolean {\n  color: #EC4242;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-null {\n  color: #EEC97D;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-undefined {\n  color: #ef8fbe;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-function {\n  color: #FD48CB;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-date {\n  background-color: rgba(255, 255, 255, 0.05);\n}\n.json-formatter-dark.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: #027BFF;\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-bracket {\n  color: #9494FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-key {\n  color: #23A0DB;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "►";\n}\n.json-formatter-dark.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-dark.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n');var l=/(^\d{1,4}[\.|\\/|-]\d{1,2}[\.|\\/|-]\d{1,4})(\s*(?:0?[1-9]:[0-5]|1(?=[012])\d:[0-5])\d\s*[ap]m)?$/,d=/\d{2}:\d{2}:\d{2} GMT-\d{4}/,c=/\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z/,p=window.requestAnimationFrame||function(t){return t(),0},j={hoverPreviewEnabled:!1,hoverPreviewArrayCount:100,hoverPreviewFieldCount:5,animateOpen:!0,animateClose:!0,theme:null,useToJSON:!0,sortPropertiesBy:null},h=function(){function t(t,e,r,n){void 0===e&&(e=1),void 0===r&&(r=j),this.json=t,this.open=e,this.config=r,this.key=n,this._isOpen=null,void 0===this.config.hoverPreviewEnabled&&(this.config.hoverPreviewEnabled=j.hoverPreviewEnabled),void 0===this.config.hoverPreviewArrayCount&&(this.config.hoverPreviewArrayCount=j.hoverPreviewArrayCount),void 0===this.config.hoverPreviewFieldCount&&(this.config.hoverPreviewFieldCount=j.hoverPreviewFieldCount),void 0===this.config.useToJSON&&(this.config.useToJSON=j.useToJSON),""===this.key&&(this.key='""')}return Object.defineProperty(t.prototype,"isOpen",{get:function(){return null!==this._isOpen?this._isOpen:this.open>0},set:function(t){this._isOpen=t},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isDate",{get:function(){return this.json instanceof Date||"string"===this.type&&(l.test(this.json)||c.test(this.json)||d.test(this.json))},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isUrl",{get:function(){return"string"===this.type&&0===this.json.indexOf("http")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isArray",{get:function(){return Array.isArray(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isObject",{get:function(){return o(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isEmptyObject",{get:function(){return!this.keys.length&&!this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isEmpty",{get:function(){return this.isEmptyObject||this.keys&&!this.keys.length&&this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"useToJSON",{get:function(){return this.config.useToJSON&&"stringifiable"===this.type},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hasKey",{get:function(){return void 0!==this.key},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"constructorName",{get:function(){return i(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"type",{get:function(){return this.config.useToJSON&&this.json&&this.json.toJSON?"stringifiable":n(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"keys",{get:function(){if(this.isObject){var t=Object.keys(this.json);return!this.isArray&&this.config.sortPropertiesBy?t.sort(this.config.sortPropertiesBy):t}return[]},enumerable:!0,configurable:!0}),t.prototype.toggleOpen=function(){this.isOpen=!this.isOpen,this.element&&(this.isOpen?this.appendChildren(this.config.animateOpen):this.removeChildren(this.config.animateClose),this.element.classList.toggle(f("open")))},t.prototype.openAtDepth=function(t){void 0===t&&(t=1),t<0||(this.open=t,this.isOpen=0!==t,this.element&&(this.removeChildren(!1),0===t?this.element.classList.remove(f("open")):(this.appendChildren(this.config.animateOpen),this.element.classList.add(f("open")))))},t.prototype.getInlinepreview=function(){var t=this;if(this.isArray)return this.json.length>this.config.hoverPreviewArrayCount?"Array["+this.json.length+"]":"["+this.json.map(a).join(", ")+"]";var e=this.keys,r=e.slice(0,this.config.hoverPreviewFieldCount).map(function(e){return e+":"+a(t.json[e])}),n=e.length>=this.config.hoverPreviewFieldCount?"…":"";return"{"+r.join(", ")+n+"}"},t.prototype.render=function(){this.element=m("div","row");var t=this.isObject?m("a","toggler-link"):m("span");if(this.isObject&&!this.useToJSON&&t.appendChild(m("span","toggler")),this.hasKey&&t.appendChild(m("span","key",this.key+":")),this.isObject&&!this.useToJSON){var e=m("span","value"),r=m("span"),n=m("span","constructor-name",this.constructorName);if(r.appendChild(n),this.isArray){var o=m("span");o.appendChild(m("span","bracket","[")),o.appendChild(m("span","number",this.json.length)),o.appendChild(m("span","bracket","]")),r.appendChild(o)}e.appendChild(r),t.appendChild(e)}else{(e=this.isUrl?m("a"):m("span")).classList.add(f(this.type)),this.isDate&&e.classList.add(f("date")),this.isUrl&&(e.classList.add(f("url")),e.setAttribute("href",this.json));var i=s(this.type,this.json,this.useToJSON?this.json.toJSON():this.json);e.appendChild(document.createTextNode(i)),t.appendChild(e)}if(this.isObject&&this.config.hoverPreviewEnabled){var a=m("span","preview-text");a.appendChild(document.createTextNode(this.getInlinepreview())),t.appendChild(a)}var l=m("div","children");return this.isObject&&l.classList.add(f("object")),this.isArray&&l.classList.add(f("array")),this.isEmpty&&l.classList.add(f("empty")),this.config&&this.config.theme&&this.element.classList.add(f(this.config.theme)),this.isOpen&&this.element.classList.add(f("open")),this.element.appendChild(t),this.element.appendChild(l),this.isObject&&this.isOpen&&this.appendChildren(),this.isObject&&!this.useToJSON&&t.addEventListener("click",this.toggleOpen.bind(this)),this.element},t.prototype.appendChildren=function(e){var r=this;void 0===e&&(e=!1);var n=this.element.querySelector("div."+f("children"));if(n&&!this.isEmpty)if(e){var o=0,i=function(){var e=r.keys[o],s=new t(r.json[e],r.open-1,r.config,e);n.appendChild(s.render()),(o+=1)<r.keys.length&&(o>10?i():p(i))};p(i)}else this.keys.forEach(function(e){var o=new t(r.json[e],r.open-1,r.config,e);n.appendChild(o.render())})},t.prototype.removeChildren=function(t){void 0===t&&(t=!1);var e=this.element.querySelector("div."+f("children"));if(t){var r=0,n=function(){e&&e.children.length&&(e.removeChild(e.children[0]),(r+=1)>10?n():p(n))};p(n)}else e&&(e.innerHTML="")},t}();e.exports=h},
"c81021c8fd": function _(t,e,n){var i,r=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),o=t("@bokehjs/models/widgets/markup"),a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return r(e,t),e.prototype.render=function(){t.prototype.render.call(this),this.markup_el.innerHTML=this.model.text,window.renderMathInElement&&window.renderMathInElement(this.el,{delimiters:[{left:"$$",right:"$$",display:!0},{left:"\\[",right:"\\]",display:!0},{left:"$",right:"$",display:!1},{left:"\\(",right:"\\)",display:!1}]})},e.__name__="KaTeXView",e}(t("ec60963462").PanelMarkupView);n.KaTeXView=a;var l=function(t){function e(e){return t.call(this,e)||this}return r(e,t),e.init_KaTeX=function(){this.prototype.default_view=a},e.__name__="KaTeX",e.__module__="panel.models.katex",e}(o.Markup);n.KaTeX=l,l.init_KaTeX()},
"a93ded647d": function _(t,e,n){var i,o=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),r=t("@bokehjs/models/widgets/markup"),a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._hub=window.MathJax.Hub,this._hub.Config({tex2jax:{inlineMath:[["$","$"],["\\(","\\)"]]}})},e.prototype.render=function(){t.prototype.render.call(this),this._hub&&(this.markup_el.innerHTML=this.model.text,this._hub.Queue(["Typeset",this._hub,this.markup_el]))},e.__name__="MathJaxView",e}(t("ec60963462").PanelMarkupView);n.MathJaxView=a;var u=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_MathJax=function(){this.prototype.default_view=a},e.__name__="MathJax",e.__module__="panel.models.mathjax",e}(r.Markup);n.MathJax=u,u.init_MathJax()},
"98100899bc": function _(t,e,i){var n,o=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/core/dom"),a=t("@bokehjs/models/widgets/widget"),l=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.change,function(){return e.render()}),this.connect(this.model.properties.value.change,function(){return e.render()}),this.connect(this.model.properties.loop_policy.change,function(){return e.set_loop_state(e.model.loop_policy)})},e.prototype.get_height=function(){return 250},e.prototype.render=function(){var e=this;if(null!=this.sliderEl)return this.sliderEl.style.width="{this.model.width}px",this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),void(this.sliderEl.value=String(this.model.value));t.prototype.render.call(this),this.sliderEl=document.createElement("input"),this.sliderEl.setAttribute("type","range"),this.sliderEl.style.width=this.model.width+"px",this.sliderEl.value=String(this.model.value),this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),this.sliderEl.onchange=function(t){return e.set_frame(parseInt(t.target.value))};var i=s.div();i.style.cssText="margin: 0 auto; display: table; padding: 5px";var n="text-align: center; min-width: 40px; margin: 2px",o=document.createElement("button");o.style.cssText="text-align: center; min-width: 20px",o.appendChild(document.createTextNode("–")),o.onclick=function(){return e.slower()},i.appendChild(o);var r=document.createElement("button");r.style.cssText=n,r.appendChild(document.createTextNode("❚◀◀")),r.onclick=function(){return e.first_frame()},i.appendChild(r);var a=document.createElement("button");a.style.cssText=n,a.appendChild(document.createTextNode("❚◀")),a.onclick=function(){return e.previous_frame()},i.appendChild(a);var l=document.createElement("button");l.style.cssText=n,l.appendChild(document.createTextNode("◀")),l.onclick=function(){return e.reverse_animation()},i.appendChild(l);var d=document.createElement("button");d.style.cssText=n,d.appendChild(document.createTextNode("❚❚")),d.onclick=function(){return e.pause_animation()},i.appendChild(d);var p=document.createElement("button");p.style.cssText=n,p.appendChild(document.createTextNode("▶")),p.onclick=function(){return e.play_animation()},i.appendChild(p);var c=document.createElement("button");c.style.cssText=n,c.appendChild(document.createTextNode("▶❚")),c.onclick=function(){return e.next_frame()},i.appendChild(c);var h=document.createElement("button");h.style.cssText=n,h.appendChild(document.createTextNode("▶▶❚")),h.onclick=function(){return e.last_frame()},i.appendChild(h);var u=document.createElement("button");u.style.cssText="text-align: center; min-width: 20px",u.appendChild(document.createTextNode("+")),u.onclick=function(){return e.faster()},i.appendChild(u),this.loop_state=document.createElement("form"),this.loop_state.style.cssText="margin: 0 auto; display: table";var m=document.createElement("input");m.type="radio",m.value="once",m.name="state";var _=document.createElement("label");_.innerHTML="Once",_.style.cssText="padding: 0 10px 0 5px; user-select:none;";var f=document.createElement("input");f.setAttribute("type","radio"),f.setAttribute("value","loop"),f.setAttribute("name","state");var v=document.createElement("label");v.innerHTML="Loop",v.style.cssText="padding: 0 10px 0 5px; user-select:none;";var y=document.createElement("input");y.setAttribute("type","radio"),y.setAttribute("value","reflect"),y.setAttribute("name","state");var x=document.createElement("label");x.innerHTML="Reflect",x.style.cssText="padding: 0 10px 0 5px; user-select:none;","once"==this.model.loop_policy?m.checked=!0:"loop"==this.model.loop_policy?f.checked=!0:y.checked=!0,this.loop_state.appendChild(m),this.loop_state.appendChild(_),this.loop_state.appendChild(f),this.loop_state.appendChild(v),this.loop_state.appendChild(y),this.loop_state.appendChild(x),this.el.appendChild(this.sliderEl),this.el.appendChild(i),this.el.appendChild(this.loop_state)},e.prototype.set_frame=function(t){this.model.value!=t&&(this.model.value=t),this.sliderEl.value!=String(t)&&(this.sliderEl.value=String(t))},e.prototype.get_loop_state=function(){for(var t=this.loop_state.state,e=0;e<t.length;e++){var i=t[e];if(i.checked)return i.value}return"once"},e.prototype.set_loop_state=function(t){for(var e=this.loop_state.state,i=0;i<e.length;i++){var n=e[i];n.value==t&&(n.checked=!0)}},e.prototype.next_frame=function(){this.set_frame(Math.min(this.model.end,this.model.value+this.model.step))},e.prototype.previous_frame=function(){this.set_frame(Math.max(this.model.start,this.model.value-this.model.step))},e.prototype.first_frame=function(){this.set_frame(this.model.start)},e.prototype.last_frame=function(){this.set_frame(this.model.end)},e.prototype.slower=function(){this.model.interval=Math.round(this.model.interval/.7),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()},e.prototype.faster=function(){this.model.interval=Math.round(.7*this.model.interval),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()},e.prototype.anim_step_forward=function(){if(this.model.value<this.model.end)this.next_frame();else{var t=this.get_loop_state();"loop"==t?this.first_frame():"reflect"==t?(this.last_frame(),this.reverse_animation()):(this.pause_animation(),this.last_frame())}},e.prototype.anim_step_reverse=function(){if(this.model.value>this.model.start)this.previous_frame();else{var t=this.get_loop_state();"loop"==t?this.last_frame():"reflect"==t?(this.first_frame(),this.play_animation()):(this.pause_animation(),this.first_frame())}},e.prototype.pause_animation=function(){this.model.direction=0,this.timer&&(clearInterval(this.timer),this.timer=null)},e.prototype.play_animation=function(){var t=this;this.pause_animation(),this.model.direction=1,this.timer||(this.timer=setInterval(function(){return t.anim_step_forward()},this.model.interval))},e.prototype.reverse_animation=function(){var t=this;this.pause_animation(),this.model.direction=-1,this.timer||(this.timer=setInterval(function(){return t.anim_step_reverse()},this.model.interval))},e.__name__="PlayerView",e}(a.WidgetView);i.PlayerView=l;var d=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_Player=function(){this.prototype.default_view=l,this.define({direction:[r.Number,0],interval:[r.Number,500],start:[r.Number],end:[r.Number],step:[r.Number,1],loop_policy:[r.Any,"once"],value:[r.Any,0]}),this.override({width:400})},e.__name__="Player",e.__module__="panel.models.widgets",e}(a.Widget);i.Player=d,d.init_Player()},
"d46f026c83": function _(t,e,o){var r,n=this&&this.__extends||(r=function(t,e){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}r(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),i=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),l=t("@bokehjs/core/util/object"),a=t("@bokehjs/core/util/eq"),p=t("@bokehjs/models/layouts/html_box"),s=t("99a25e6992"),u=t("62ba79515f"),c=t("ec60963462"),_=window.Plotly,d=function(t,e,o){var r=Array.isArray(e)?[]:{};if("click"===o||"hover"===o||"selected"===o){var n=[];if(null==e)return null;for(var i=t.data,l=0;l<e.points.length;l++){var a=e.points[l],p={};for(var s in a){var c=a[s];!a.hasOwnProperty(s)||Array.isArray(c)||u.isPlainObject(c)||(p[s]=c)}null!=a&&(a.hasOwnProperty("curveNumber")&&a.hasOwnProperty("pointNumber")&&i[a.curveNumber].hasOwnProperty("customdata")&&(p.customdata=i[a.curveNumber].customdata[a.pointNumber]),a.hasOwnProperty("pointNumbers")&&(p.pointNumbers=a.pointNumbers)),n[l]=p}r.points=n}else if("relayout"===o||"restyle"===o)for(var s in e)e.hasOwnProperty(s)&&(r[s]=e[s]);return e.hasOwnProperty("range")&&(r.range=e.range),e.hasOwnProperty("lassoPoints")&&(r.lassoPoints=e.lassoPoints),r},y=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._settingViewport=!1,e._plotInitialized=!1,e._reacting=!1,e._relayouting=!1,e._end_relayouting=s.debounce(function(){e._relayouting=!1},2e3,!1),e}return n(e,t),e.prototype.connect_signals=function(){t.prototype.connect_signals.call(this),this.connect(this.model.properties.viewport_update_policy.change,this._updateSetViewportFunction),this.connect(this.model.properties.viewport_update_throttle.change,this._updateSetViewportFunction),this.connect(this.model.properties._render_count.change,this.plot),this.connect(this.model.properties.viewport.change,this._updateViewportFromProperty)},e.prototype.render=function(){t.prototype.render.call(this),window.Plotly&&this.plot()},e.prototype.plot=function(){var t=this;if(window.Plotly){for(var e=[],o=0;o<this.model.data.length;o++)e.push(this._get_trace(o,!1));var r=u.deepCopy(this.model.layout);if(this._relayouting){var n=this.el.layout;Object.keys(n).reduce(function(t,e){"axis"===e.slice(1,5)&&"range"in t&&(r[e].range=t.range)},{})}this._reacting=!0,_.react(this.el,e,r,this.model.config).then(function(){t._updateSetViewportFunction(),t._updateViewportProperty(),t._plotInitialized||(t.el.on("plotly_relayout",function(e){!0!==e._update_from_property&&(t.model.relayout_data=d(t.el,e,"relayout"),t._updateViewportProperty(),t._end_relayouting())}),t.el.on("plotly_relayouting",function(){"mouseup"!==t.model.viewport_update_policy&&(t._relayouting=!0,t._updateViewportProperty())}),t.el.on("plotly_restyle",function(e){t.model.restyle_data=d(t.el,e,"restyle"),t._updateViewportProperty()}),t.el.on("plotly_click",function(e){t.model.click_data=d(t.el,e,"click")}),t.el.on("plotly_hover",function(e){t.model.hover_data=d(t.el,e,"hover")}),t.el.on("plotly_selected",function(e){t.model.selected_data=d(t.el,e,"selected")}),t.el.on("plotly_clickannotation",function(e){delete e.event,delete e.fullAnnotation,t.model.clickannotation_data=e}),t.el.on("plotly_deselect",function(){t.model.selected_data=null}),t.el.on("plotly_unhover",function(){t.model.hover_data=null})),t._plotInitialized=!0,t._reacting=!1})}},e.prototype._get_trace=function(t,e){for(var o=l.clone(this.model.data[t]),r=this.model.data_sources[t],n=0,i=r.columns();n<i.length;n++){var a=i[n],p=r._shapes[a][0],s=r.get_array(a)[0];if(p.length>1){for(var u=[],c=0;c<p[0];c++)u.push(s.slice(c*p[1],(c+1)*p[1]));s=u}for(var _=a.split("."),d=_[_.length-1],y=o,h=0,f=_.slice(0,-1);h<f.length;h++){y=y[f[h]]}e&&1==_.length?y[d]=[s]:y[d]=s}return o},e.prototype._updateViewportFromProperty=function(){var t=this;if(_&&!this._settingViewport&&!this._reacting&&this.model.viewport){var e=this.el._fullLayout;Object.keys(this.model.viewport).reduce(function(o,r){if(a.isEqual(u.get(e,r),o))return!0;var n=u.deepCopy(t.model.viewport);return n._update_from_property=!0,_.relayout(t.el,n),!1},{})}},e.prototype._updateViewportProperty=function(){var t=this.el._fullLayout,e={};for(var o in t)if(t.hasOwnProperty(o)){var r=o.slice(0,5);"xaxis"!==r&&"yaxis"!==r||(e[o+".range"]=u.deepCopy(t[o].range))}a.isEqual(e,this.model.viewport)||this._setViewport(e)},e.prototype._updateSetViewportFunction=function(){var t=this;"continuous"===this.model.viewport_update_policy||"mouseup"===this.model.viewport_update_policy?this._setViewport=function(e){t._settingViewport||(t._settingViewport=!0,t.model.viewport=e,t._settingViewport=!1)}:this._setViewport=u.throttle(function(e){t._settingViewport||(t._settingViewport=!0,t.model.viewport=e,t._settingViewport=!1)},this.model.viewport_update_throttle)},e.__name__="PlotlyPlotView",e}(c.PanelHTMLBoxView);o.PlotlyPlotView=y;var h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_PlotlyPlot=function(){this.prototype.default_view=y,this.define({data:[i.Array,[]],layout:[i.Any,{}],config:[i.Any,{}],data_sources:[i.Array,[]],relayout_data:[i.Any,{}],restyle_data:[i.Array,[]],click_data:[i.Any,{}],hover_data:[i.Any,{}],clickannotation_data:[i.Any,{}],selected_data:[i.Any,{}],viewport:[i.Any,{}],viewport_update_policy:[i.String,"mouseup"],viewport_update_throttle:[i.Number,200],_render_count:[i.Number,0]})},e.__name__="PlotlyPlot",e.__module__="panel.models.plotly",e}(p.HTMLBox);o.PlotlyPlot=h,h.init_PlotlyPlot()},
"99a25e6992": function _(n,l,u){function t(n,l,u){var t,e,o,a,r;function i(){var c=Date.now()-a;c<l&&c>=0?t=setTimeout(i,l-c):(t=null,u||(r=n.apply(o,e),o=e=null))}null==l&&(l=100);var c=function(){o=this,e=arguments,a=Date.now();var c=u&&!t;return t||(t=setTimeout(i,l)),c&&(r=n.apply(o,e),o=e=null),r};return c.clear=function(){t&&(clearTimeout(t),t=null)},c.flush=function(){t&&(r=n.apply(o,e),o=e=null,clearTimeout(t),t=null)},c}t.debounce=t,l.exports=t},
"62ba79515f": function _(t,r,n){n.get=function(t,r,n){void 0===n&&(n=void 0);var e=function(n){return String.prototype.split.call(r,n).filter(Boolean).reduce(function(t,r){return null!=t?t[r]:t},t)},o=e(/[,[\]]+?/)||e(/[,[\].]+?/);return void 0===o||o===t?n:o},n.throttle=function(t,r){var n=0;return function(){var e=Number(new Date);e-n>=r&&(t(),n=e)}},n.deepCopy=function t(r){var n;if(null==r||"object"!=typeof r)return r;if(r instanceof Array){n=[];for(var e=0,o=r.length;e<o;e++)n[e]=t(r[e]);return n}if(r instanceof Object){var i={};for(var u in r){var c=u;r.hasOwnProperty(c)&&(i[c]=t(r[c]))}return i}throw new Error("Unable to copy obj! Its type isn't supported.")},n.isPlainObject=function(t){return"[object Object]"===Object.prototype.toString.call(t)}},
"d9b3a262de": function _(t,e,o){var s,i=this&&this.__extends||(s=function(t,e){return(s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}s(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),n=this&&this.__assign||function(){return(n=Object.assign||function(t){for(var e,o=1,s=arguments.length;o<s;o++)for(var i in e=arguments[o])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t}).apply(this,arguments)},r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),c=t("@bokehjs/models/layouts/html_box"),l=t("ec60963462"),h=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this);var o=function(){e.render(),e.root.compute_layout()};this.connect(this.model.properties.height.change,o),this.connect(this.model.properties.width.change,o),this.connect(this.model.properties.height_policy.change,o),this.connect(this.model.properties.width_policy.change,o),this.connect(this.model.properties.sizing_mode.change,o),this.connect(this.model.properties.active.change,function(){return e.setCSS()}),this.connect(this.model.properties.bar_color.change,function(){return e.setCSS()}),this.connect(this.model.properties.css_classes.change,function(){return e.setCSS()}),this.connect(this.model.properties.value.change,function(){return e.setValue()}),this.connect(this.model.properties.max.change,function(){return e.setMax()})},e.prototype.render=function(){t.prototype.render.call(this);var e=n(n({},this.model.style),{display:"inline-block"});for(var o in this.progressEl=document.createElement("progress"),this.setValue(),this.setMax(),l.set_size(this.progressEl,this.model),this.setCSS(),e)this.progressEl.style.setProperty(o,e[o]);this.el.appendChild(this.progressEl)},e.prototype.setCSS=function(){var t=this.model.css_classes.join(" ")+" "+this.model.bar_color;this.model.active&&(t+=" active"),this.progressEl.className=t},e.prototype.setValue=function(){null!=this.model.value&&(this.progressEl.value=this.model.value)},e.prototype.setMax=function(){null!=this.model.max&&(this.progressEl.max=this.model.max)},e.prototype._update_layout=function(){var t=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l.CachedVariadicBox(this.el,this.model.sizing_mode,t),this.layout.set_sizing(this.box_sizing())},e.__name__="ProgressView",e}(c.HTMLBoxView);o.ProgressView=h;var a=function(t){function e(e){return t.call(this,e)||this}return i(e,t),e.init_Progress=function(){this.prototype.default_view=h,this.define({active:[r.Boolean,!0],bar_color:[r.String,"primary"],style:[r.Any,{}],max:[r.Number,100],value:[r.Number,null]})},e.__name__="Progress",e.__module__="panel.models.widgets",e}(c.HTMLBox);o.Progress=a,a.init_Progress()},
"4b4afba86a": function _(t,e,n){var o,i=this&&this.__extends||(o=function(t,e){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}o(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/core/view"),a=t("@bokehjs/core/util/array"),c=t("@bokehjs/model"),_=t("@bokehjs/protocol/receiver");var h=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.renderTo=function(){},e.__name__="StateView",e}(s.View);n.StateView=h;var p=function(t){function e(e){var n=t.call(this,e)||this;return n._receiver=new _.Receiver,n._cache={},n}return i(e,t),e.prototype.apply_state=function(t){this._receiver.consume(t.header),this._receiver.consume(t.metadata),this._receiver.consume(t.content),this._receiver.message&&this.document&&this.document.apply_json_patch(this._receiver.message.content)},e.prototype._receive_json=function(t,e){var n=JSON.parse(t);this._cache[e]=n;for(var o=this.state,i=0,r=this.values;i<r.length;i++){o=o[r[i]]}o===e?this.apply_state(n):this._cache[o]&&this.apply_state(this._cache[o])},e.prototype.set_state=function(t,e){var n=this,o=a.copy(this.values);o[this.widgets[t.id]]=e;for(var i,r,s,c=this.state,_=0,h=o;_<h.length;_++){var p=h[_];c=c[p]}this.values=o,this.json?this._cache[c]?this.apply_state(this._cache[c]):(i=c,r=function(t){return n._receive_json(t,c)},(s=new XMLHttpRequest).overrideMimeType("application/json"),s.open("GET",i,!0),s.onreadystatechange=function(){4==s.readyState&&200==s.status&&r(s.responseText)},s.send(null)):this.apply_state(c)},e.init_State=function(){this.prototype.default_view=h,this.define({json:[r.Boolean,!1],state:[r.Any,{}],widgets:[r.Any,{}],values:[r.Any,[]]})},e.__name__="State",e.__module__="panel.models.state",e}(c.Model);n.State=p,p.init_State()},
"14b669e6fc": function _(t,e,o){var n,a=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),s=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),i=t("@bokehjs/models/layouts/html_box"),r=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return a(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.data.change,this._plot),this.connect(this.model.properties.data_sources.change,function(){return e._connect_sources()}),this._connected=[],this._connect_sources()},e.prototype._connect_sources=function(){for(var t in this.model.data_sources){var e=this.model.data_sources[t];this._connected.indexOf(t)<0&&(this.connect(e.properties.data.change,this._plot),this._connected.push(t))}},e.prototype._fetch_datasets=function(){var t={};for(var e in this.model.data_sources){for(var o=this.model.data_sources[e],n=[],a=o.columns(),s=0;s<o.data[a[0]].length;s++){for(var i={},r=0,c=a;r<c.length;r++){var d=c[r];i[d]=o.data[d][s]}n.push(i)}t[e]=n}return t},e.prototype.render=function(){t.prototype.render.call(this),this._plot()},e.prototype._plot=function(){if(this.model.data&&window.vegaEmbed){if(this.model.data_sources&&Object.keys(this.model.data_sources).length>0){var t=this._fetch_datasets();if("data"in t&&(this.model.data.data.values=t.data,delete t.data),void 0!==this.model.data.data)for(var e=0,o=this.model.data.data;e<o.length;e++){var n=o[e];n.name in t&&(n.values=t[n.name],delete t[n.name])}this.model.data.datasets=t}window.vegaEmbed(this.el,this.model.data,{actions:!1})}},e.__name__="VegaPlotView",e}(i.HTMLBoxView);o.VegaPlotView=r;var c=function(t){function e(e){return t.call(this,e)||this}return a(e,t),e.init_VegaPlot=function(){this.prototype.default_view=r,this.define({data:[s.Any],data_sources:[s.Any]})},e.__name__="VegaPlot",e.__module__="panel.models.vega",e}(i.HTMLBox);o.VegaPlot=c,c.init_VegaPlot()},
"71a2bbec38": function _(e,t,o){var i,n=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o])})(e,t)},function(e,t){function o(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),l=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var o in e)Object.hasOwnProperty.call(e,o)&&(t[o]=e[o]);return t.default=e,t})(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype.initialize=function(){e.prototype.initialize.call(this),this._blocked=!1,this._setting=!1,this._time=Date.now()},t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.loop.change,function(){return t.set_loop()}),this.connect(this.model.properties.paused.change,function(){return t.set_paused()}),this.connect(this.model.properties.time.change,function(){return t.set_time()}),this.connect(this.model.properties.value.change,function(){return t.set_value()}),this.connect(this.model.properties.volume.change,function(){return t.set_volume()})},t.prototype.render=function(){var t=this;e.prototype.render.call(this),this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.videoEl.controls=!0,this.videoEl.src=this.model.value,this.videoEl.currentTime=this.model.time,this.videoEl.loop=this.model.loop,null!=this.model.volume?this.videoEl.volume=this.model.volume/100:this.model.volume=100*this.videoEl.volume,this.videoEl.onpause=function(){return t.model.paused=!0},this.videoEl.onplay=function(){return t.model.paused=!1},this.videoEl.ontimeupdate=function(){return t.update_time(t)},this.videoEl.onvolumechange=function(){return t.update_volume(t)},this.el.appendChild(this.videoEl),this.model.paused||this.videoEl.play()},t.prototype.update_time=function(e){e._setting?e._setting=!1:Date.now()-e._time<e.model.throttle||(e._blocked=!0,e.model.time=e.videoEl.currentTime,e._time=Date.now())},t.prototype.update_volume=function(e){e._setting?e._setting=!1:(e._blocked=!0,e.model.volume=100*e.videoEl.volume)},t.prototype.set_loop=function(){this.videoEl.loop=this.model.loop},t.prototype.set_paused=function(){!this.videoEl.paused&&this.model.paused&&this.videoEl.pause(),this.videoEl.paused&&!this.model.paused&&this.videoEl.play()},t.prototype.set_volume=function(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.videoEl.volume=this.model.volume/100))},t.prototype.set_time=function(){this._blocked?this._blocked=!1:(this._setting=!0,this.videoEl.currentTime=this.model.time)},t.prototype.set_value=function(){this.videoEl.src=this.model.value},t.__name__="VideoView",t}(e("ec60963462").PanelHTMLBoxView);o.VideoView=d;var h=function(e){function t(t){return e.call(this,t)||this}return n(t,e),t.init_Video=function(){this.prototype.default_view=d,this.define({loop:[l.Boolean,!1],paused:[l.Boolean,!0],time:[l.Number,0],throttle:[l.Number,250],value:[l.Any,""],volume:[l.Number,null]})},t.__name__="Video",t.__module__="panel.models.widgets",t}(s.HTMLBox);o.Video=h,h.init_Video()},
"76bc93d621": function _(t,e,i){var o,n=this&&this.__extends||(o=function(t,e){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}o(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),s=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e})(t("@bokehjs/core/properties")),r=t("@bokehjs/models/layouts/html_box"),h=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e.constraints={audio:!1,video:!0},e}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),null!==this.model.timeout&&this.set_timeout()},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.timeout.change,function(){return e.set_timeout()}),this.connect(this.model.properties.snapshot.change,function(){return e.snapshot()}),this.connect(this.model.properties.paused.change,function(){return e.pause()})},e.prototype.pause=function(){this.model.paused&&(null!=this.timer&&(clearInterval(this.timer),this.timer=null),this.videoEl.pause()),this.set_timeout()},e.prototype.set_timeout=function(){var t=this;this.timer&&(clearInterval(this.timer),this.timer=null),this.model.timeout>0&&(this.timer=setInterval(function(){return t.snapshot()},this.model.timeout))},e.prototype.snapshot=function(){this.canvasEl.width=this.videoEl.videoWidth,this.canvasEl.height=this.videoEl.videoHeight;var t=this.canvasEl.getContext("2d");t&&t.drawImage(this.videoEl,0,0,this.canvasEl.width,this.canvasEl.height),this.model.value=this.canvasEl.toDataURL("image/"+this.model.format,.95)},e.prototype.remove=function(){t.prototype.remove.call(this),this.timer&&(clearInterval(this.timer),this.timer=null)},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this.videoEl||(this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.canvasEl=document.createElement("canvas"),this.el.appendChild(this.videoEl),navigator.mediaDevices.getUserMedia&&navigator.mediaDevices.getUserMedia(this.constraints).then(function(t){e.videoEl.srcObject=t,e.model.paused||e.videoEl.play()}).catch(console.error))},e.__name__="VideoStreamView",e}(t("ec60963462").PanelHTMLBoxView);i.VideoStreamView=h;var a=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_VideoStream=function(){this.prototype.default_view=h,this.define({format:[s.String,"png"],paused:[s.Boolean,!1],snapshot:[s.Boolean,!1],timeout:[s.Number,0],value:[s.Any]}),this.override({height:240,width:320})},e.__name__="VideoStream",e.__module__="panel.models.widgets",e}(r.HTMLBox);i.VideoStream=a,a.init_VideoStream()},
"63070bc9ce": function _(V,o,e){var l=V("1a4b530306");e.VTKPlot=l.VTKPlot;var K=V("b933e81f56");e.VTKVolumePlot=K.VTKVolumePlot;var T=V("5bc27423fe");e.VTKAxes=T.VTKAxes},
"1a4b530306": function _(e,t,n){var i,o=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),r=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)Object.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t.default=e,t})(e("@bokehjs/core/properties")),a=e("@bokehjs/core/dom"),s=e("7620c2cc05"),c=e("3b847a648d"),d=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._axes_initialized=!1,t}return o(t,e),t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.axes.change,function(){t._delete_axes(),t.model.axes&&t._set_axes(),t._vtk_renwin.getRenderWindow().render()}),this.el.addEventListener("mouseenter",function(){var e=t._vtk_renwin.getInteractor();t.model.enable_keybindings&&(document.querySelector("body").addEventListener("keypress",e.handleKeyPress),document.querySelector("body").addEventListener("keydown",e.handleKeyDown),document.querySelector("body").addEventListener("keyup",e.handleKeyUp))}),this.el.addEventListener("mouseleave",function(){var e=t._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)})},t.prototype.render=function(){e.prototype.render.call(this),this._axes=null,this._axes_initialized=!1,this._plot()},t.prototype.after_layout=function(){this._axes_initialized||(this._render_axes_canvas(),this._axes_initialized=!0)},t.prototype._render_axes_canvas=function(){var e=this,t=this._vtk_container.getElementsByTagName("canvas");if(1!=t.length)throw Error("Error at initialization of the 3D scene, container should have one and only one canvas");t[0].classList.add("scene3d-canvas");var n=a.canvas({style:{position:"absolute",top:"0",left:"0",width:"100%",height:"100%"}});n.classList.add("axes-canvas"),this._vtk_container.appendChild(n),this._vtk_renwin.setResizeCallback(function(){var t=e._vtk_container.getBoundingClientRect(),i=Math.floor(t.width*window.devicePixelRatio),o=Math.floor(t.height*window.devicePixelRatio);n.setAttribute("width",i.toFixed()),n.setAttribute("height",o.toFixed())})},t.prototype._delete_axes=function(){var e=this;if(null!=this._axes){Object.keys(this._axes).forEach(function(t){return e._vtk_renwin.getRenderer().removeActor(e._axes[t])});var t=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],n=t.getContext("2d");n&&n.clearRect(0,0,t.clientWidth*window.devicePixelRatio,t.clientHeight*window.devicePixelRatio),this._axes=null}},t.prototype._set_axes=function(){if(this.model.axes){var e=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],t=this.model.axes.create_axes(e),n=t.psActor,i=t.axesActor,o=t.gridActor;this._axes={psActor:n,axesActor:i,gridActor:o},this._vtk_renwin.getRenderer().addActor(n),this._vtk_renwin.getRenderer().addActor(i),this._vtk_renwin.getRenderer().addActor(o)}},t.prototype._plot=function(){var e=this;if(this.model.data)var t=c.vtkns.DataAccessHelper.get("zip",{zipContent:atob(this.model.data),callback:function(n){var i=c.vtkns.HttpSceneLoader.newInstance({renderer:e._vtk_renwin.getRenderer(),dataAccessHelper:t}),o=c.vtk.macro.debounce(function(){null==e._axes&&e.model.axes&&e._set_axes(),e.model.properties.camera.change.emit()},100);i.setUrl("index.json"),i.onReady(o)}});else this._vtk_renwin.getRenderWindow().render()},t.__name__="VTKPlotView",t}(s.AbstractVTKView);n.VTKPlotView=d;var l=function(e){function t(t){var n=e.call(this,t)||this;n.outline=c.vtkns.OutlineFilter.newInstance();var i=c.vtkns.Mapper.newInstance();return i.setInputConnection(n.outline.getOutputPort()),n.outline_actor=c.vtkns.Actor.newInstance(),n.outline_actor.setMapper(i),n}return o(t,e),t.init_VTKPlot=function(){this.prototype.default_view=d,this.define({data:[r.String],axes:[r.Instance],enable_keybindings:[r.Boolean,!1]})},t.__name__="VTKPlot",t}(s.AbstractVTKPlot);n.VTKPlot=l,l.init_VTKPlot()},
"7620c2cc05": function _(e,t,n){var i,r=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)Object.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t.default=e,t})(e("@bokehjs/core/properties")),a=e("@bokehjs/core/dom"),s=e("@bokehjs/core/util/object"),_=e("@bokehjs/models/layouts/html_box"),c=e("ec60963462"),d=e("3b847a648d"),h=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._setting_camera=!1,t}return r(t,e),t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.data.change,function(){t.invalidate_render()}),this.connect(this.model.properties.orientation_widget.change,function(){t._orientation_widget_visibility(t.model.orientation_widget)}),this.connect(this.model.properties.camera.change,function(){return t._set_camera_state()})},t.prototype._orientation_widget_visibility=function(e){this._orientationWidget.setEnabled(e),e?this._widgetManager.enablePicking():this._widgetManager.disablePicking(),this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderWindow().render()},t.prototype._create_orientation_widget=function(){var e=this,t=d.vtkns.AxesActor.newInstance(),n=d.vtkns.OrientationMarkerWidget.newInstance({actor:t,interactor:this._vtk_renwin.getInteractor()});n.setEnabled(!0),n.setViewportCorner(d.vtkns.OrientationMarkerWidget.Corners.BOTTOM_RIGHT),n.setViewportSize(.15),n.setMinPixelSize(100),n.setMaxPixelSize(300),this._orientationWidget=n;var i=d.vtkns.WidgetManager.newInstance();i.setRenderer(n.getRenderer());var r=d.vtkns.InteractiveOrientationWidget.newInstance();r.placeWidget(t.getBounds()),r.setBounds(t.getBounds()),r.setPlaceFactor(1);var o=i.addWidget(r);this._widgetManager=i,o.onOrientationChange(function(t){var n=t.direction,i=e._vtk_renwin.getRenderer().getActiveCamera(),r=i.getFocalPoint(),o=i.getPosition(),a=i.getViewUp(),s=Math.sqrt(Math.pow(o[0]-r[0],2)+Math.pow(o[1]-r[1],2)+Math.pow(o[2]-r[2],2));i.setPosition(r[0]+n[0]*s,r[1]+n[1]*s,r[2]+n[2]*s),n[0]&&i.setViewUp(d.majorAxis(a,1,2)),n[1]&&i.setViewUp(d.majorAxis(a,0,2)),n[2]&&i.setViewUp(d.majorAxis(a,0,1)),e._orientationWidget.updateMarkerOrientation(),e._vtk_renwin.getRenderer().resetCameraClippingRange(),e._vtk_renwin.getRenderWindow().render()}),this._orientation_widget_visibility(this.model.orientation_widget)},t.prototype._get_camera_state=function(){if(!this._setting_camera){this._setting_camera=!0;var e=s.clone(this._vtk_renwin.getRenderer().getActiveCamera().get());delete e.classHierarchy,delete e.vtkObject,delete e.vtkCamera,delete e.viewPlaneNormal,this.model.camera=e,this._setting_camera=!1}},t.prototype._set_camera_state=function(){if(!this._setting_camera){this._setting_camera=!0;try{this.model.camera&&this._vtk_renwin.getRenderer().getActiveCamera().set(this.model.camera)}finally{this._setting_camera=!1}this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderer().resetCameraClippingRange(),this._vtk_renwin.getRenderWindow().render()}},t.prototype.render=function(){var t=this;e.prototype.render.call(this),this._orientationWidget=null,this._vtk_container=a.div(),c.set_size(this._vtk_container,this.model),this.el.appendChild(this._vtk_container),this._vtk_renwin=d.vtkns.FullScreenRenderWindow.newInstance({rootContainer:this.el,container:this._vtk_container}),this._remove_default_key_binding(),this._create_orientation_widget(),this._vtk_renwin.getRenderer().getActiveCamera().onModified(function(){return t._get_camera_state()}),this._set_camera_state(),this.model.renderer_el=this._vtk_renwin},t.prototype.after_layout=function(){e.prototype.after_layout.call(this),this._vtk_renwin.resize()},t.prototype._remove_default_key_binding=function(){var e=this._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)},t.__name__="AbstractVTKView",t}(c.PanelHTMLBoxView);n.AbstractVTKView=h;var l=function(e){function t(t){return e.call(this,t)||this}return r(t,e),t.prototype.getActors=function(){return this.renderer_el.getRenderer().getActors()},t.init_AbstractVTKPlot=function(){this.define({orientation_widget:[o.Boolean,!1],camera:[o.Instance]}),this.override({height:300,width:300})},t.__name__="AbstractVTKPlot",t.__module__="panel.models.vtk",t}(_.HTMLBox);n.AbstractVTKPlot=l,l.init_AbstractVTKPlot()},
"3b847a648d": function _(e,t,n){var r=e("@bokehjs/core/util/serialization"),a=e("@bokehjs/core/util/array");function o(e){var t=Math.min(Math.max(Math.round(e),0),255).toString(16);return 2==t.length?t:"0"+t}function i(e,t,n){return"#"+o(e)+o(t)+o(n)}function v(e){for(var t=new ArrayBuffer(e.length),n=new Uint8Array(t),r=0,a=e.length;r<a;r++)n[r]=e.charCodeAt(r);return t}n.vtk=window.vtk,n.vtkns={},n.vtk&&(n.vtkns.DataArray=n.vtk.Common.Core.vtkDataArray,n.vtkns.ImageData=n.vtk.Common.DataModel.vtkImageData,n.vtkns.OutlineFilter=n.vtk.Filters.General.vtkOutlineFilter,n.vtkns.CubeSource=n.vtk.Filters.Sources.vtkCubeSource,n.vtkns.LineSource=n.vtk.Filters.Sources.vtkLineSource,n.vtkns.PlaneSource=n.vtk.Filters.Sources.vtkPlaneSource,n.vtkns.PointSource=n.vtk.Filters.Sources.vtkPointSource,n.vtkns.OrientationMarkerWidget=n.vtk.Interaction.Widgets.vtkOrientationMarkerWidget,n.vtkns.DataAccessHelper=n.vtk.IO.Core.DataAccessHelper,n.vtkns.HttpSceneLoader=n.vtk.IO.Core.vtkHttpSceneLoader,n.vtkns.ImageSlice=n.vtk.Rendering.Core.vtkImageSlice,n.vtkns.Actor=n.vtk.Rendering.Core.vtkActor,n.vtkns.AxesActor=n.vtk.Rendering.Core.vtkAxesActor,n.vtkns.Mapper=n.vtk.Rendering.Core.vtkMapper,n.vtkns.ImageMapper=n.vtk.Rendering.Core.vtkImageMapper,n.vtkns.SphereMapper=n.vtk.Rendering.Core.vtkSphereMapper,n.vtkns.WidgetManager=n.vtk.Widgets.Core.vtkWidgetManager,n.vtkns.InteractiveOrientationWidget=n.vtk.Widgets.Widgets3D.vtkInteractiveOrientationWidget,n.vtkns.PixelSpaceCallbackMapper=n.vtk.Rendering.Core.vtkPixelSpaceCallbackMapper,n.vtkns.FullScreenRenderWindow=n.vtk.Rendering.Misc.vtkFullScreenRenderWindow,n.vtkns.VolumeController=n.vtk.Interaction.UI.vtkVolumeController,n.vtkns.Volume=n.vtk.Rendering.Core.vtkVolume,n.vtkns.VolumeMapper=n.vtk.Rendering.Core.vtkVolumeMapper,n.vtkns.ColorTransferFunction=n.vtk.Rendering.Core.vtkColorTransferFunction,n.vtkns.PiecewiseFunction=n.vtk.Common.DataModel.vtkPiecewiseFunction,n.vtkns.BoundingBox=n.vtk.Common.DataModel.vtkBoundingBox),n.hexToRGB=function(e){return[parseInt(e.slice(1,3),16)/255,parseInt(e.slice(3,5),16)/255,parseInt(e.slice(5,7),16)/255]},n.rgbToHex=i,n.vtkLutToMapper=function(e){var t=e.get("scale","nodes"),r=t.scale,o=t.nodes;if(r!==n.vtkns.ColorTransferFunction.Scale.LINEAR)throw"Error transfer function scale not handle";var v=o.map(function(e){return e.x}),k=Math.min.apply(Math,v),s=Math.max.apply(Math,v),c=a.linspace(k,s,255),u=[0,0,0];return{low:k,high:s,palette:c.map(function(t){return e.getColor(t,u),i(255*u[0],255*u[1],255*u[2])})}},n.data2VTKImageData=function(e){var t=n.vtkns.ImageData.newInstance({spacing:e.spacing});t.setDimensions(e.dims),t.setOrigin(null!=e.origin?e.origin:e.dims.map(function(e){return e/2}));var a=n.vtkns.DataArray.newInstance({name:"scalars",numberOfComponents:1,values:new r.ARRAY_TYPES[e.dtype](v(atob(e.buffer)))});return t.getPointData().setScalars(a),t},n.majorAxis=function(e,t,n){var r=[0,0,0],a=Math.abs(e[t])>Math.abs(e[n])?t:n,o=e[a]>0?1:-1;return r[a]=o,r},n.cartesian_product=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return e.reduce(function(e,t){return e.flatMap(function(e){return t.map(function(t){return[].concat(e,t)})})})}},
"b933e81f56": function _(e,t,n){var r,i=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)Object.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t.default=e,t})(e("@bokehjs/core/properties")),s=e("7620c2cc05"),a=e("3b847a648d"),l=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return i(t,e),t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.colormap.change,function(){t.colormap_slector.value=t.model.colormap;var e=new Event("change");t.colormap_slector.dispatchEvent(e)}),this.connect(this.model.properties.shadow.change,function(){t.shadow_selector.value=t.model.shadow?"1":"0";var e=new Event("change");t.shadow_selector.dispatchEvent(e)}),this.connect(this.model.properties.sampling.change,function(){t.sampling_slider.value=t.model.sampling.toFixed(2);var e=new Event("input");t.sampling_slider.dispatchEvent(e)}),this.connect(this.model.properties.edge_gradient.change,function(){t.edge_gradient_slider.value=t.model.edge_gradient.toFixed(2);var e=new Event("input");t.edge_gradient_slider.dispatchEvent(e)}),this.connect(this.model.properties.rescale.change,function(){t._controllerWidget.setRescaleColorMap(t.model.rescale),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.ambient.change,function(){t.volume.getProperty().setAmbient(t.model.ambient),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.diffuse.change,function(){t.volume.getProperty().setDiffuse(t.model.diffuse),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular.change,function(){t.volume.getProperty().setSpecular(t.model.specular),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular_power.change,function(){t.volume.getProperty().setSpecularPower(t.model.specular_power),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_volume.change,function(){t._set_volume_visibility(t.model.display_volume),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_slices.change,function(){t._set_slices_visibility(t.model.display_slices),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_i.change,function(){t.image_actor_i.getMapper().setISlice(t.model.slice_i),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_j.change,function(){t.image_actor_j.getMapper().setJSlice(t.model.slice_j),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_k.change,function(){t.image_actor_k.getMapper().setKSlice(t.model.slice_k),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.render_background.change,function(){var e;(e=t._vtk_renwin.getRenderer()).setBackground.apply(e,a.hexToRGB(t.model.render_background)),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.interpolation.change,function(){t._set_interpolation(t.model.interpolation),t._vtk_renwin.getRenderWindow().render()})},Object.defineProperty(t.prototype,"volume",{get:function(){return this._controllerWidget.getActor()},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_i",{get:function(){return this._vtk_renwin.getRenderer().getActors()[0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_j",{get:function(){return this._vtk_renwin.getRenderer().getActors()[1]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_k",{get:function(){return this._vtk_renwin.getRenderer().getActors()[2]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"shadow_selector",{get:function(){return this.el.querySelector(".js-shadow")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"edge_gradient_slider",{get:function(){return this.el.querySelector(".js-edge")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"sampling_slider",{get:function(){return this.el.querySelector(".js-spacing")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"colormap_slector",{get:function(){return this.el.querySelector(".js-color-preset")},enumerable:!0,configurable:!0}),t.prototype._set_interpolation=function(e){"fast_linear"==e?(this.volume.getProperty().setInterpolationTypeToFastLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):"linear"==e?(this.volume.getProperty().setInterpolationTypeToLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):(this.volume.getProperty().setInterpolationTypeToNearest(),this.image_actor_i.getProperty().setInterpolationTypeToNearest())},t.prototype.render=function(){var t;e.prototype.render.call(this),this._controllerWidget=a.vtkns.VolumeController.newInstance({size:[400,150],rescaleColorMap:this.model.rescale}),this._vtk_image_data=a.data2VTKImageData(this.model.data),this._controllerWidget.setContainer(this.el),this._vtk_renwin.getRenderWindow().getInteractor(),this._vtk_renwin.getRenderWindow().getInteractor().setDesiredUpdateRate(45),this._plot_volume(),this._connect_controls(),this._plot_slices(),this._set_volume_visibility(this.model.display_volume),this._set_slices_visibility(this.model.display_slices),(t=this._vtk_renwin.getRenderer()).setBackground.apply(t,a.hexToRGB(this.model.render_background)),this._set_interpolation(this.model.interpolation),this._vtk_renwin.getRenderer().resetCamera()},t.prototype._connect_controls=function(){var e=this;this.colormap_slector.addEventListener("change",function(){e.model.colormap=e.colormap_slector.value}),this.model.colormap?this.model.properties.colormap.change.emit():this.model.colormap=this.colormap_slector.value,this.shadow_selector.addEventListener("change",function(){e.model.shadow=!!Number(e.shadow_selector.value)}),(this.model.shadow=!!Number(this.shadow_selector.value))&&this.model.properties.shadow.change.emit(),this.sampling_slider.addEventListener("input",function(){var t=Number(e.sampling_slider.value);Math.abs(e.model.sampling-t)>=.005&&(e.model.sampling=t)}),Math.abs(this.model.sampling-Number(this.shadow_selector.value))>=.005&&this.model.properties.sampling.change.emit(),this.edge_gradient_slider.addEventListener("input",function(){var t=Number(e.edge_gradient_slider.value);Math.abs(e.model.edge_gradient-t)>=.005&&(e.model.edge_gradient=t)}),Math.abs(this.model.edge_gradient-Number(this.edge_gradient_slider.value))>=.005&&this.model.properties.edge_gradient.change.emit()},t.prototype._plot_volume=function(){var e=this,t=this._vtk_image_data,n=a.vtkns.Volume.newInstance(),r=a.vtkns.VolumeMapper.newInstance();n.setMapper(r),r.setInputData(t);var i=(t.getPointData().getScalars()||t.getPointData().getArrays()[0]).getRange(),o=a.vtkns.ColorTransferFunction.newInstance();o.onModified(function(){return e.model.mapper=a.vtkLutToMapper(o)});var s=a.vtkns.PiecewiseFunction.newInstance(),l=.7*Math.sqrt(t.getSpacing().map(function(e){return e*e}).reduce(function(e,t){return e+t},0));r.setSampleDistance(l),n.getProperty().setRGBTransferFunction(0,o),n.getProperty().setScalarOpacity(0,s),n.getProperty().setInterpolationTypeToFastLinear(),n.getProperty().setScalarOpacityUnitDistance(0,a.vtkns.BoundingBox.getDiagonalLength(t.getBounds())/Math.max.apply(Math,t.getDimensions())),n.getProperty().setGradientOpacityMinimumValue(0,0),n.getProperty().setGradientOpacityMaximumValue(0,.05*(i[1]-i[0])),n.getProperty().setShade(this.model.shadow),n.getProperty().setUseGradientOpacity(0,!0),n.getProperty().setGradientOpacityMinimumOpacity(0,0),n.getProperty().setGradientOpacityMaximumOpacity(0,1),n.getProperty().setAmbient(this.model.ambient),n.getProperty().setDiffuse(this.model.diffuse),n.getProperty().setSpecular(this.model.specular),n.getProperty().setSpecularPower(this.model.specular_power),this._vtk_renwin.getRenderer().addVolume(n),this._controllerWidget.setupContent(this._vtk_renwin.getRenderWindow(),n,!0)},t.prototype._plot_slices=function(){var e=this._vtk_image_data,t=a.vtkns.ImageSlice.newInstance(),n=a.vtkns.ImageSlice.newInstance(),r=a.vtkns.ImageSlice.newInstance(),i=a.vtkns.ImageMapper.newInstance(),o=a.vtkns.ImageMapper.newInstance(),s=a.vtkns.ImageMapper.newInstance();i.setInputData(e),i.setISlice(this.model.slice_i),t.setMapper(i),o.setInputData(e),o.setJSlice(this.model.slice_j),n.setMapper(o),s.setInputData(e),s.setKSlice(this.model.slice_k),r.setMapper(s);var l=a.vtkns.PiecewiseFunction.newInstance();l.removeAllPoints(),l.addPoint(0,1);var c=this.volume.getProperty().getRGBTransferFunction(0),p=t.getProperty();n.setProperty(p),r.setProperty(p),p.setRGBTransferFunction(c),p.setScalarOpacity(l);var d=this._vtk_renwin.getRenderer();d.addActor(t),d.addActor(n),d.addActor(r)},t.prototype._set_volume_visibility=function(e){this.volume.setVisibility(e)},t.prototype._set_slices_visibility=function(e){this._vtk_renwin.getRenderer().getActors().map(function(t){return t.setVisibility(e)})},t.__name__="VTKVolumePlotView",t}(s.AbstractVTKView);n.VTKVolumePlotView=l;var c=function(e){function t(t){return e.call(this,t)||this}return i(t,e),t.init_VTKVolumePlot=function(){this.prototype.default_view=l,this.define({data:[o.Instance],shadow:[o.Boolean,!0],sampling:[o.Number,.4],edge_gradient:[o.Number,.2],colormap:[o.String],rescale:[o.Boolean,!1],ambient:[o.Number,.2],diffuse:[o.Number,.7],specular:[o.Number,.3],specular_power:[o.Number,8],slice_i:[o.Int,0],slice_j:[o.Int,0],slice_k:[o.Int,0],display_volume:[o.Boolean,!0],display_slices:[o.Boolean,!1],render_background:[o.String,"#52576e"],interpolation:[o.Any,"fast_linear"],mapper:[o.Instance]})},t.__name__="VTKVolumePlot",t}(s.AbstractVTKPlot);n.VTKVolumePlot=c,c.init_VTKVolumePlot()},
"5bc27423fe": function _(t,e,i){var s,n=this&&this.__extends||(s=function(t,e){return(s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}s(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),r=this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e},a=t("66e1dbda7d"),c=t("@bokehjs/model"),o=r(t("@bokehjs/core/properties")),l=t("3b847a648d"),h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_VTKAxes=function(){this.define({origin:[o.Array],xticker:[o.Instance],yticker:[o.Instance],zticker:[o.Instance],digits:[o.Number,1],show_grid:[o.Boolean,!0],grid_opacity:[o.Number,.1],axes_opacity:[o.Number,1],fontsize:[o.Number,12]})},Object.defineProperty(e.prototype,"xticks",{get:function(){return this.xticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"yticks",{get:function(){return this.yticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"zticks",{get:function(){return this.zticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"xlabels",{get:function(){var t=this;return this.xticker.labels?this.xticker.labels:this.xticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"ylabels",{get:function(){var t=this;return this.yticker.labels?this.yticker.labels:this.yticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"zlabels",{get:function(){var t=this;return this.zticker.labels?this.zticker.labels:this.zticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),e.prototype._make_grid_lines=function(t,e,i){for(var s=[],n=0;n<t-1;n++)for(var r=0;r<e-1;r++){var a=n*e+r+i,c=[5,a,n*e+r+1+i,(n+1)*e+r+1+i,(n+1)*e+r+i,a];s.push(c)}return s},e.prototype._create_grid_axes=function(){var t=[];t.push(l.cartesian_product(this.xticks,this.yticks,[this.origin[2]])),t.push(l.cartesian_product([this.origin[0]],this.yticks,this.zticks)),t.push(l.cartesian_product(this.xticks,[this.origin[1]],this.zticks));var e=[],i=0;e.push(this._make_grid_lines(this.xticks.length,this.yticks.length,i)),i+=this.xticks.length*this.yticks.length,e.push(this._make_grid_lines(this.yticks.length,this.zticks.length,i)),i+=this.yticks.length*this.zticks.length,e.push(this._make_grid_lines(this.xticks.length,this.zticks.length,i));var s=l.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:t.flat(2)},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:e.flat(2)}}),n=l.vtkns.Mapper.newInstance(),r=l.vtkns.Actor.newInstance();return n.setInputData(s),r.setMapper(n),r.getProperty().setOpacity(this.grid_opacity),r.setVisibility(this.show_grid),r},e.prototype.create_axes=function(t){var e=this,i=[this.xticks,this.yticks,this.zticks].map(function(t,i){var s=null;switch(i){case 0:s=l.cartesian_product(t,[e.origin[1]],[e.origin[2]]);break;case 1:s=l.cartesian_product([e.origin[0]],t,[e.origin[2]]);break;case 2:s=l.cartesian_product([e.origin[0]],[e.origin[1]],t)}return s}).flat(2),s=l.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:i},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:[2,0,this.xticks.length-1,2,this.xticks.length,this.xticks.length+this.yticks.length-1,2,this.xticks.length+this.yticks.length,this.xticks.length+this.yticks.length+this.zticks.length-1]}}),n=l.vtkns.PixelSpaceCallbackMapper.newInstance();n.setInputData(s),n.setUseZValues(!0),n.setCallback(function(i,s,r){var c=t.getContext("2d");if(c){var o={height:t.clientHeight*window.devicePixelRatio,width:t.clientWidth*window.devicePixelRatio},l=n.getInputData().getPoints(),h=s.getViewMatrix();a.mat4.transpose(h,h);var p=s.getProjectionMatrix(r,-1,1);a.mat4.transpose(p,p),c.clearRect(0,0,o.width,o.height),i.forEach(function(t,i){var s=l.getPoint(i),n=a.vec3.fromValues(s[0],s[1],s[2]);if(a.vec3.transformMat4(n,n,h),n[2]+=.05,a.vec3.transformMat4(n,n,p),n[2]-.001<t[3]){c.font="30px serif",c.textAlign="center",c.textBaseline="alphabetic",c.fillText(".",t[0],o.height-t[1]+2),c.font=e.fontsize*window.devicePixelRatio+"px serif",c.textAlign="right",c.textBaseline="top";var r=void 0;r=i<e.xticks.length?e.xlabels[i]:i>=e.xticks.length&&i<e.xticks.length+e.yticks.length?e.ylabels[i-e.xticks.length]:e.zlabels[i-(e.xticks.length+e.yticks.length)],c.fillText(""+r,t[0],o.height-t[1])}})}});var r=l.vtkns.Actor.newInstance();r.setMapper(n);var c=l.vtkns.Mapper.newInstance();c.setInputData(s);var o=l.vtkns.Actor.newInstance();return o.setMapper(c),o.getProperty().setOpacity(this.axes_opacity),{psActor:r,axesActor:o,gridActor:this._create_grid_axes()}},e.__name__="VTKAxes",e.__module__="panel.models.vtk",e}(c.Model);i.VTKAxes=h,h.init_VTKAxes()},
"66e1dbda7d": function _(t,e,r){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.vec4=r.vec3=r.vec2=r.quat2=r.quat=r.mat4=r.mat3=r.mat2d=r.mat2=r.glMatrix=void 0;var n=m(t("c6b4e451bc"));r.glMatrix=n;var o=m(t("4483d2d159"));r.mat2=o;var c=m(t("6e68b9b04c"));r.mat2d=c;var u=m(t("4dc492e8e1"));r.mat3=u;var f=m(t("948401a902"));r.mat4=f;var i=m(t("8b81ae2f8b"));r.quat=i;var v=m(t("27670309ba"));r.quat2=v;var b=m(t("62ac52b540"));r.vec2=b;var y=m(t("2e13827733"));r.vec3=y;var l=m(t("03254e8a21"));function p(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return p=function(){return t},t}function m(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var e=p();if(e&&e.has(t))return e.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var c=n?Object.getOwnPropertyDescriptor(t,o):null;c&&(c.get||c.set)?Object.defineProperty(r,o,c):r[o]=t[o]}return r.default=t,e&&e.set(t,r),r}r.vec4=l},
"c6b4e451bc": function _(a,t,r){r.setMatrixArrayType=function(a){r.ARRAY_TYPE=o=a},r.toRadian=function(a){return a*A},r.equals=function(a,t){return Math.abs(a-t)<=n*Math.max(1,Math.abs(a),Math.abs(t))},r.RANDOM=r.ARRAY_TYPE=r.EPSILON=void 0;var n=1e-6;r.EPSILON=n;var o="undefined"!=typeof Float32Array?Float32Array:Array;r.ARRAY_TYPE=o;var h=Math.random;r.RANDOM=h;var A=Math.PI/180;Math.hypot||(Math.hypot=function(){for(var a=0,t=arguments.length;t--;)a+=arguments[t]*arguments[t];return Math.sqrt(a)})},
"4483d2d159": function _(t,n,r){function e(t){return(e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=function(){var t=new u.ARRAY_TYPE(4);u.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0);return t[0]=1,t[3]=1,t},r.clone=function(t){var n=new u.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},r.fromValues=function(t,n,r,e){var a=new u.ARRAY_TYPE(4);return a[0]=t,a[1]=n,a[2]=r,a[3]=e,a},r.set=function(t,n,r,e,u){return t[0]=n,t[1]=r,t[2]=e,t[3]=u,t},r.transpose=function(t,n){if(t===n){var r=n[1];t[1]=n[2],t[2]=r}else t[0]=n[0],t[1]=n[2],t[2]=n[1],t[3]=n[3];return t},r.invert=function(t,n){var r=n[0],e=n[1],u=n[2],a=n[3],o=r*a-u*e;if(!o)return null;return o=1/o,t[0]=a*o,t[1]=-e*o,t[2]=-u*o,t[3]=r*o,t},r.adjoint=function(t,n){var r=n[0];return t[0]=n[3],t[1]=-n[1],t[2]=-n[2],t[3]=r,t},r.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},r.multiply=o,r.rotate=function(t,n,r){var e=n[0],u=n[1],a=n[2],o=n[3],i=Math.sin(r),c=Math.cos(r);return t[0]=e*c+a*i,t[1]=u*c+o*i,t[2]=e*-i+a*c,t[3]=u*-i+o*c,t},r.scale=function(t,n,r){var e=n[0],u=n[1],a=n[2],o=n[3],i=r[0],c=r[1];return t[0]=e*i,t[1]=u*i,t[2]=a*c,t[3]=o*c,t},r.fromRotation=function(t,n){var r=Math.sin(n),e=Math.cos(n);return t[0]=e,t[1]=r,t[2]=-r,t[3]=e,t},r.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t},r.str=function(t){return"mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3])},r.LDU=function(t,n,r,e){return t[2]=e[2]/e[0],r[0]=e[0],r[1]=e[1],r[3]=e[3]-t[2]*r[1],[t,n,r]},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},r.subtract=i,r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},r.equals=function(t,n){var r=t[0],e=t[1],a=t[2],o=t[3],i=n[0],c=n[1],f=n[2],l=n[3];return Math.abs(r-i)<=u.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(e-c)<=u.EPSILON*Math.max(1,Math.abs(e),Math.abs(c))&&Math.abs(a-f)<=u.EPSILON*Math.max(1,Math.abs(a),Math.abs(f))&&Math.abs(o-l)<=u.EPSILON*Math.max(1,Math.abs(o),Math.abs(l))},r.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},r.multiplyScalarAndAdd=function(t,n,r,e){return t[0]=n[0]+r[0]*e,t[1]=n[1]+r[1]*e,t[2]=n[2]+r[2]*e,t[3]=n[3]+r[3]*e,t},r.sub=r.mul=void 0;var u=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==e(t)&&"function"!=typeof t)return{default:t};var n=a();if(n&&n.has(t))return n.get(t);var r={},u=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=u?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function a(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return a=function(){return t},t}function o(t,n,r){var e=n[0],u=n[1],a=n[2],o=n[3],i=r[0],c=r[1],f=r[2],l=r[3];return t[0]=e*i+a*c,t[1]=u*i+o*c,t[2]=e*f+a*l,t[3]=u*f+o*l,t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}var c=o;r.mul=c;var f=i;r.sub=f},
"6e68b9b04c": function _(t,n,r){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=function(){var t=new e.ARRAY_TYPE(6);e.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0);return t[0]=1,t[3]=1,t},r.clone=function(t){var n=new e.ARRAY_TYPE(6);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},r.fromValues=function(t,n,r,a,u,o){var i=new e.ARRAY_TYPE(6);return i[0]=t,i[1]=n,i[2]=r,i[3]=a,i[4]=u,i[5]=o,i},r.set=function(t,n,r,a,e,u,o){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t},r.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],c=r*u-a*e;if(!c)return null;return c=1/c,t[0]=u*c,t[1]=-a*c,t[2]=-e*c,t[3]=r*c,t[4]=(e*i-u*o)*c,t[5]=(a*o-r*i)*c,t},r.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},r.multiply=o,r.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],c=n[5],f=Math.sin(r),s=Math.cos(r);return t[0]=a*s+u*f,t[1]=e*s+o*f,t[2]=a*-f+u*s,t[3]=e*-f+o*s,t[4]=i,t[5]=c,t},r.scale=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],c=n[5],f=r[0],s=r[1];return t[0]=a*f,t[1]=e*f,t[2]=u*s,t[3]=o*s,t[4]=i,t[5]=c,t},r.translate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],c=n[5],f=r[0],s=r[1];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=a*f+u*s+i,t[5]=e*f+o*s+c,t},r.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=-r,t[3]=a,t[4]=0,t[5]=0,t},r.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t[4]=0,t[5]=0,t},r.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=n[0],t[5]=n[1],t},r.str=function(t){return"mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],1)},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t},r.subtract=i,r.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t},r.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t[4]=n[4]+r[4]*a,t[5]=n[5]+r[5]*a,t},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]},r.equals=function(t,n){var r=t[0],a=t[1],u=t[2],o=t[3],i=t[4],c=t[5],f=n[0],s=n[1],l=n[2],b=n[3],h=n[4],M=n[5];return Math.abs(r-f)<=e.EPSILON*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(a-s)<=e.EPSILON*Math.max(1,Math.abs(a),Math.abs(s))&&Math.abs(u-l)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(l))&&Math.abs(o-b)<=e.EPSILON*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(i-h)<=e.EPSILON*Math.max(1,Math.abs(i),Math.abs(h))&&Math.abs(c-M)<=e.EPSILON*Math.max(1,Math.abs(c),Math.abs(M))},r.sub=r.mul=void 0;var e=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var n=u();if(n&&n.has(t))return n.get(t);var r={},e=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=e?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function u(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return u=function(){return t},t}function o(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],c=n[5],f=r[0],s=r[1],l=r[2],b=r[3],h=r[4],M=r[5];return t[0]=a*f+u*s,t[1]=e*f+o*s,t[2]=a*l+u*b,t[3]=e*l+o*b,t[4]=a*h+u*M+i,t[5]=e*h+o*M+c,t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t[4]=n[4]-r[4],t[5]=n[5]-r[5],t}var c=o;r.mul=c;var f=i;r.sub=f},
"4dc492e8e1": function _(t,n,r){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=function(){var t=new e.ARRAY_TYPE(9);e.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0);return t[0]=1,t[4]=1,t[8]=1,t},r.fromMat4=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[4],t[4]=n[5],t[5]=n[6],t[6]=n[8],t[7]=n[9],t[8]=n[10],t},r.clone=function(t){var n=new e.ARRAY_TYPE(9);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n[6]=t[6],n[7]=t[7],n[8]=t[8],n},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t},r.fromValues=function(t,n,r,a,u,o,i,f,c){var s=new e.ARRAY_TYPE(9);return s[0]=t,s[1]=n,s[2]=r,s[3]=a,s[4]=u,s[5]=o,s[6]=i,s[7]=f,s[8]=c,s},r.set=function(t,n,r,a,e,u,o,i,f,c){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=f,t[8]=c,t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.transpose=function(t,n){if(t===n){var r=n[1],a=n[2],e=n[5];t[1]=n[3],t[2]=n[6],t[3]=r,t[5]=n[7],t[6]=a,t[7]=e}else t[0]=n[0],t[1]=n[3],t[2]=n[6],t[3]=n[1],t[4]=n[4],t[5]=n[7],t[6]=n[2],t[7]=n[5],t[8]=n[8];return t},r.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],f=n[6],c=n[7],s=n[8],M=s*o-i*c,b=-s*u+i*f,h=c*u-o*f,l=r*M+a*b+e*h;if(!l)return null;return l=1/l,t[0]=M*l,t[1]=(-s*a+e*c)*l,t[2]=(i*a-e*o)*l,t[3]=b*l,t[4]=(s*r-e*f)*l,t[5]=(-i*r+e*u)*l,t[6]=h*l,t[7]=(-c*r+a*f)*l,t[8]=(o*r-a*u)*l,t},r.adjoint=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],f=n[6],c=n[7],s=n[8];return t[0]=o*s-i*c,t[1]=e*c-a*s,t[2]=a*i-e*o,t[3]=i*f-u*s,t[4]=r*s-e*f,t[5]=e*u-r*i,t[6]=u*c-o*f,t[7]=a*f-r*c,t[8]=r*o-a*u,t},r.determinant=function(t){var n=t[0],r=t[1],a=t[2],e=t[3],u=t[4],o=t[5],i=t[6],f=t[7],c=t[8];return n*(c*u-o*f)+r*(-c*e+o*i)+a*(f*e-u*i)},r.multiply=o,r.translate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],f=n[5],c=n[6],s=n[7],M=n[8],b=r[0],h=r[1];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=i,t[5]=f,t[6]=b*a+h*o+c,t[7]=b*e+h*i+s,t[8]=b*u+h*f+M,t},r.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],f=n[5],c=n[6],s=n[7],M=n[8],b=Math.sin(r),h=Math.cos(r);return t[0]=h*a+b*o,t[1]=h*e+b*i,t[2]=h*u+b*f,t[3]=h*o-b*a,t[4]=h*i-b*e,t[5]=h*f-b*u,t[6]=c,t[7]=s,t[8]=M,t},r.scale=function(t,n,r){var a=r[0],e=r[1];return t[0]=a*n[0],t[1]=a*n[1],t[2]=a*n[2],t[3]=e*n[3],t[4]=e*n[4],t[5]=e*n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t},r.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=n[0],t[7]=n[1],t[8]=1,t},r.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=0,t[3]=-r,t[4]=a,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=0,t[4]=n[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.fromMat2d=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=0,t[3]=n[2],t[4]=n[3],t[5]=0,t[6]=n[4],t[7]=n[5],t[8]=1,t},r.fromQuat=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r+r,i=a+a,f=e+e,c=r*o,s=a*o,M=a*i,b=e*o,h=e*i,l=e*f,m=u*o,y=u*i,p=u*f;return t[0]=1-M-l,t[3]=s-p,t[6]=b+y,t[1]=s+p,t[4]=1-c-l,t[7]=h-m,t[2]=b-y,t[5]=h+m,t[8]=1-c-M,t},r.normalFromMat4=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],f=n[6],c=n[7],s=n[8],M=n[9],b=n[10],h=n[11],l=n[12],m=n[13],y=n[14],p=n[15],v=r*i-a*o,P=r*f-e*o,O=r*c-u*o,S=a*f-e*i,d=a*c-u*i,E=e*c-u*f,A=s*m-M*l,x=s*y-b*l,I=s*p-h*l,L=M*y-b*m,N=M*p-h*m,R=b*p-h*y,j=v*R-P*N+O*L+S*I-d*x+E*A;if(!j)return null;return j=1/j,t[0]=(i*R-f*N+c*L)*j,t[1]=(f*I-o*R-c*x)*j,t[2]=(o*N-i*I+c*A)*j,t[3]=(e*N-a*R-u*L)*j,t[4]=(r*R-e*I+u*x)*j,t[5]=(a*I-r*N-u*A)*j,t[6]=(m*E-y*d+p*S)*j,t[7]=(y*O-l*E-p*P)*j,t[8]=(l*d-m*O+p*v)*j,t},r.projection=function(t,n,r){return t[0]=2/n,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/r,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},r.str=function(t){return"mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t[6]=n[6]+r[6],t[7]=n[7]+r[7],t[8]=n[8]+r[8],t},r.subtract=i,r.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t[6]=n[6]*r,t[7]=n[7]*r,t[8]=n[8]*r,t},r.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t[4]=n[4]+r[4]*a,t[5]=n[5]+r[5]*a,t[6]=n[6]+r[6]*a,t[7]=n[7]+r[7]*a,t[8]=n[8]+r[8]*a,t},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]&&t[6]===n[6]&&t[7]===n[7]&&t[8]===n[8]},r.equals=function(t,n){var r=t[0],a=t[1],u=t[2],o=t[3],i=t[4],f=t[5],c=t[6],s=t[7],M=t[8],b=n[0],h=n[1],l=n[2],m=n[3],y=n[4],p=n[5],v=n[6],P=n[7],O=n[8];return Math.abs(r-b)<=e.EPSILON*Math.max(1,Math.abs(r),Math.abs(b))&&Math.abs(a-h)<=e.EPSILON*Math.max(1,Math.abs(a),Math.abs(h))&&Math.abs(u-l)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(l))&&Math.abs(o-m)<=e.EPSILON*Math.max(1,Math.abs(o),Math.abs(m))&&Math.abs(i-y)<=e.EPSILON*Math.max(1,Math.abs(i),Math.abs(y))&&Math.abs(f-p)<=e.EPSILON*Math.max(1,Math.abs(f),Math.abs(p))&&Math.abs(c-v)<=e.EPSILON*Math.max(1,Math.abs(c),Math.abs(v))&&Math.abs(s-P)<=e.EPSILON*Math.max(1,Math.abs(s),Math.abs(P))&&Math.abs(M-O)<=e.EPSILON*Math.max(1,Math.abs(M),Math.abs(O))},r.sub=r.mul=void 0;var e=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var n=u();if(n&&n.has(t))return n.get(t);var r={},e=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=e?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function u(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return u=function(){return t},t}function o(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],f=n[5],c=n[6],s=n[7],M=n[8],b=r[0],h=r[1],l=r[2],m=r[3],y=r[4],p=r[5],v=r[6],P=r[7],O=r[8];return t[0]=b*a+h*o+l*c,t[1]=b*e+h*i+l*s,t[2]=b*u+h*f+l*M,t[3]=m*a+y*o+p*c,t[4]=m*e+y*i+p*s,t[5]=m*u+y*f+p*M,t[6]=v*a+P*o+O*c,t[7]=v*e+P*i+O*s,t[8]=v*u+P*f+O*M,t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t[4]=n[4]-r[4],t[5]=n[5]-r[5],t[6]=n[6]-r[6],t[7]=n[7]-r[7],t[8]=n[8]-r[8],t}var f=o;r.mul=f;var c=i;r.sub=c},
"948401a902": function _(t,a,n){function r(t){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}n.create=function(){var t=new o.ARRAY_TYPE(16);o.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0);return t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},n.clone=function(t){var a=new o.ARRAY_TYPE(16);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a[9]=t[9],a[10]=t[10],a[11]=t[11],a[12]=t[12],a[13]=t[13],a[14]=t[14],a[15]=t[15],a},n.copy=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},n.fromValues=function(t,a,n,r,e,u,h,i,M,s,f,c,b,l,v,m){var p=new o.ARRAY_TYPE(16);return p[0]=t,p[1]=a,p[2]=n,p[3]=r,p[4]=e,p[5]=u,p[6]=h,p[7]=i,p[8]=M,p[9]=s,p[10]=f,p[11]=c,p[12]=b,p[13]=l,p[14]=v,p[15]=m,p},n.set=function(t,a,n,r,o,e,u,h,i,M,s,f,c,b,l,v,m){return t[0]=a,t[1]=n,t[2]=r,t[3]=o,t[4]=e,t[5]=u,t[6]=h,t[7]=i,t[8]=M,t[9]=s,t[10]=f,t[11]=c,t[12]=b,t[13]=l,t[14]=v,t[15]=m,t},n.identity=u,n.transpose=function(t,a){if(t===a){var n=a[1],r=a[2],o=a[3],e=a[6],u=a[7],h=a[11];t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=n,t[6]=a[9],t[7]=a[13],t[8]=r,t[9]=e,t[11]=a[14],t[12]=o,t[13]=u,t[14]=h}else t[0]=a[0],t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=a[1],t[5]=a[5],t[6]=a[9],t[7]=a[13],t[8]=a[2],t[9]=a[6],t[10]=a[10],t[11]=a[14],t[12]=a[3],t[13]=a[7],t[14]=a[11],t[15]=a[15];return t},n.invert=function(t,a){var n=a[0],r=a[1],o=a[2],e=a[3],u=a[4],h=a[5],i=a[6],M=a[7],s=a[8],f=a[9],c=a[10],b=a[11],l=a[12],v=a[13],m=a[14],p=a[15],y=n*h-r*u,P=n*i-o*u,S=n*M-e*u,O=r*i-o*h,E=r*M-e*h,I=o*M-e*i,L=s*v-f*l,N=s*m-c*l,R=s*p-b*l,x=f*m-c*v,d=f*p-b*v,g=c*p-b*m,A=y*g-P*d+S*x+O*R-E*N+I*L;if(!A)return null;return A=1/A,t[0]=(h*g-i*d+M*x)*A,t[1]=(o*d-r*g-e*x)*A,t[2]=(v*I-m*E+p*O)*A,t[3]=(c*E-f*I-b*O)*A,t[4]=(i*R-u*g-M*N)*A,t[5]=(n*g-o*R+e*N)*A,t[6]=(m*S-l*I-p*P)*A,t[7]=(s*I-c*S+b*P)*A,t[8]=(u*d-h*R+M*L)*A,t[9]=(r*R-n*d-e*L)*A,t[10]=(l*E-v*S+p*y)*A,t[11]=(f*S-s*E-b*y)*A,t[12]=(h*N-u*x-i*L)*A,t[13]=(n*x-r*N+o*L)*A,t[14]=(v*P-l*O-m*y)*A,t[15]=(s*O-f*P+c*y)*A,t},n.adjoint=function(t,a){var n=a[0],r=a[1],o=a[2],e=a[3],u=a[4],h=a[5],i=a[6],M=a[7],s=a[8],f=a[9],c=a[10],b=a[11],l=a[12],v=a[13],m=a[14],p=a[15];return t[0]=h*(c*p-b*m)-f*(i*p-M*m)+v*(i*b-M*c),t[1]=-(r*(c*p-b*m)-f*(o*p-e*m)+v*(o*b-e*c)),t[2]=r*(i*p-M*m)-h*(o*p-e*m)+v*(o*M-e*i),t[3]=-(r*(i*b-M*c)-h*(o*b-e*c)+f*(o*M-e*i)),t[4]=-(u*(c*p-b*m)-s*(i*p-M*m)+l*(i*b-M*c)),t[5]=n*(c*p-b*m)-s*(o*p-e*m)+l*(o*b-e*c),t[6]=-(n*(i*p-M*m)-u*(o*p-e*m)+l*(o*M-e*i)),t[7]=n*(i*b-M*c)-u*(o*b-e*c)+s*(o*M-e*i),t[8]=u*(f*p-b*v)-s*(h*p-M*v)+l*(h*b-M*f),t[9]=-(n*(f*p-b*v)-s*(r*p-e*v)+l*(r*b-e*f)),t[10]=n*(h*p-M*v)-u*(r*p-e*v)+l*(r*M-e*h),t[11]=-(n*(h*b-M*f)-u*(r*b-e*f)+s*(r*M-e*h)),t[12]=-(u*(f*m-c*v)-s*(h*m-i*v)+l*(h*c-i*f)),t[13]=n*(f*m-c*v)-s*(r*m-o*v)+l*(r*c-o*f),t[14]=-(n*(h*m-i*v)-u*(r*m-o*v)+l*(r*i-o*h)),t[15]=n*(h*c-i*f)-u*(r*c-o*f)+s*(r*i-o*h),t},n.determinant=function(t){var a=t[0],n=t[1],r=t[2],o=t[3],e=t[4],u=t[5],h=t[6],i=t[7],M=t[8],s=t[9],f=t[10],c=t[11],b=t[12],l=t[13],v=t[14],m=t[15];return(a*u-n*e)*(f*m-c*v)-(a*h-r*e)*(s*m-c*l)+(a*i-o*e)*(s*v-f*l)+(n*h-r*u)*(M*m-c*b)-(n*i-o*u)*(M*v-f*b)+(r*i-o*h)*(M*l-s*b)},n.multiply=h,n.translate=function(t,a,n){var r,o,e,u,h,i,M,s,f,c,b,l,v=n[0],m=n[1],p=n[2];a===t?(t[12]=a[0]*v+a[4]*m+a[8]*p+a[12],t[13]=a[1]*v+a[5]*m+a[9]*p+a[13],t[14]=a[2]*v+a[6]*m+a[10]*p+a[14],t[15]=a[3]*v+a[7]*m+a[11]*p+a[15]):(r=a[0],o=a[1],e=a[2],u=a[3],h=a[4],i=a[5],M=a[6],s=a[7],f=a[8],c=a[9],b=a[10],l=a[11],t[0]=r,t[1]=o,t[2]=e,t[3]=u,t[4]=h,t[5]=i,t[6]=M,t[7]=s,t[8]=f,t[9]=c,t[10]=b,t[11]=l,t[12]=r*v+h*m+f*p+a[12],t[13]=o*v+i*m+c*p+a[13],t[14]=e*v+M*m+b*p+a[14],t[15]=u*v+s*m+l*p+a[15]);return t},n.scale=function(t,a,n){var r=n[0],o=n[1],e=n[2];return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*o,t[5]=a[5]*o,t[6]=a[6]*o,t[7]=a[7]*o,t[8]=a[8]*e,t[9]=a[9]*e,t[10]=a[10]*e,t[11]=a[11]*e,t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},n.rotate=function(t,a,n,r){var e,u,h,i,M,s,f,c,b,l,v,m,p,y,P,S,O,E,I,L,N,R,x,d,g=r[0],A=r[1],Y=r[2],T=Math.hypot(g,A,Y);if(T<o.EPSILON)return null;g*=T=1/T,A*=T,Y*=T,e=Math.sin(n),u=Math.cos(n),h=1-u,i=a[0],M=a[1],s=a[2],f=a[3],c=a[4],b=a[5],l=a[6],v=a[7],m=a[8],p=a[9],y=a[10],P=a[11],S=g*g*h+u,O=A*g*h+Y*e,E=Y*g*h-A*e,I=g*A*h-Y*e,L=A*A*h+u,N=Y*A*h+g*e,R=g*Y*h+A*e,x=A*Y*h-g*e,d=Y*Y*h+u,t[0]=i*S+c*O+m*E,t[1]=M*S+b*O+p*E,t[2]=s*S+l*O+y*E,t[3]=f*S+v*O+P*E,t[4]=i*I+c*L+m*N,t[5]=M*I+b*L+p*N,t[6]=s*I+l*L+y*N,t[7]=f*I+v*L+P*N,t[8]=i*R+c*x+m*d,t[9]=M*R+b*x+p*d,t[10]=s*R+l*x+y*d,t[11]=f*R+v*x+P*d,a!==t&&(t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t},n.rotateX=function(t,a,n){var r=Math.sin(n),o=Math.cos(n),e=a[4],u=a[5],h=a[6],i=a[7],M=a[8],s=a[9],f=a[10],c=a[11];a!==t&&(t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[4]=e*o+M*r,t[5]=u*o+s*r,t[6]=h*o+f*r,t[7]=i*o+c*r,t[8]=M*o-e*r,t[9]=s*o-u*r,t[10]=f*o-h*r,t[11]=c*o-i*r,t},n.rotateY=function(t,a,n){var r=Math.sin(n),o=Math.cos(n),e=a[0],u=a[1],h=a[2],i=a[3],M=a[8],s=a[9],f=a[10],c=a[11];a!==t&&(t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[0]=e*o-M*r,t[1]=u*o-s*r,t[2]=h*o-f*r,t[3]=i*o-c*r,t[8]=e*r+M*o,t[9]=u*r+s*o,t[10]=h*r+f*o,t[11]=i*r+c*o,t},n.rotateZ=function(t,a,n){var r=Math.sin(n),o=Math.cos(n),e=a[0],u=a[1],h=a[2],i=a[3],M=a[4],s=a[5],f=a[6],c=a[7];a!==t&&(t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[0]=e*o+M*r,t[1]=u*o+s*r,t[2]=h*o+f*r,t[3]=i*o+c*r,t[4]=M*o-e*r,t[5]=s*o-u*r,t[6]=f*o-h*r,t[7]=c*o-i*r,t},n.fromTranslation=function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=a[0],t[13]=a[1],t[14]=a[2],t[15]=1,t},n.fromScaling=function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=a[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotation=function(t,a,n){var r,e,u,h=n[0],i=n[1],M=n[2],s=Math.hypot(h,i,M);if(s<o.EPSILON)return null;return h*=s=1/s,i*=s,M*=s,r=Math.sin(a),e=Math.cos(a),u=1-e,t[0]=h*h*u+e,t[1]=i*h*u+M*r,t[2]=M*h*u-i*r,t[3]=0,t[4]=h*i*u-M*r,t[5]=i*i*u+e,t[6]=M*i*u+h*r,t[7]=0,t[8]=h*M*u+i*r,t[9]=i*M*u-h*r,t[10]=M*M*u+e,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromXRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=r,t[6]=n,t[7]=0,t[8]=0,t[9]=-n,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromYRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=0,t[2]=-n,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=n,t[9]=0,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromZRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=0,t[3]=0,t[4]=-n,t[5]=r,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotationTranslation=i,n.fromQuat2=function(t,a){var n=new o.ARRAY_TYPE(3),r=-a[0],e=-a[1],u=-a[2],h=a[3],M=a[4],s=a[5],f=a[6],c=a[7],b=r*r+e*e+u*u+h*h;b>0?(n[0]=2*(M*h+c*r+s*u-f*e)/b,n[1]=2*(s*h+c*e+f*r-M*u)/b,n[2]=2*(f*h+c*u+M*e-s*r)/b):(n[0]=2*(M*h+c*r+s*u-f*e),n[1]=2*(s*h+c*e+f*r-M*u),n[2]=2*(f*h+c*u+M*e-s*r));return i(t,a,n),t},n.getTranslation=function(t,a){return t[0]=a[12],t[1]=a[13],t[2]=a[14],t},n.getScaling=M,n.getRotation=function(t,a){var n=new o.ARRAY_TYPE(3);M(n,a);var r=1/n[0],e=1/n[1],u=1/n[2],h=a[0]*r,i=a[1]*e,s=a[2]*u,f=a[4]*r,c=a[5]*e,b=a[6]*u,l=a[8]*r,v=a[9]*e,m=a[10]*u,p=h+c+m,y=0;p>0?(y=2*Math.sqrt(p+1),t[3]=.25*y,t[0]=(b-v)/y,t[1]=(l-s)/y,t[2]=(i-f)/y):h>c&&h>m?(y=2*Math.sqrt(1+h-c-m),t[3]=(b-v)/y,t[0]=.25*y,t[1]=(i+f)/y,t[2]=(l+s)/y):c>m?(y=2*Math.sqrt(1+c-h-m),t[3]=(l-s)/y,t[0]=(i+f)/y,t[1]=.25*y,t[2]=(b+v)/y):(y=2*Math.sqrt(1+m-h-c),t[3]=(i-f)/y,t[0]=(l+s)/y,t[1]=(b+v)/y,t[2]=.25*y);return t},n.fromRotationTranslationScale=function(t,a,n,r){var o=a[0],e=a[1],u=a[2],h=a[3],i=o+o,M=e+e,s=u+u,f=o*i,c=o*M,b=o*s,l=e*M,v=e*s,m=u*s,p=h*i,y=h*M,P=h*s,S=r[0],O=r[1],E=r[2];return t[0]=(1-(l+m))*S,t[1]=(c+P)*S,t[2]=(b-y)*S,t[3]=0,t[4]=(c-P)*O,t[5]=(1-(f+m))*O,t[6]=(v+p)*O,t[7]=0,t[8]=(b+y)*E,t[9]=(v-p)*E,t[10]=(1-(f+l))*E,t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t},n.fromRotationTranslationScaleOrigin=function(t,a,n,r,o){var e=a[0],u=a[1],h=a[2],i=a[3],M=e+e,s=u+u,f=h+h,c=e*M,b=e*s,l=e*f,v=u*s,m=u*f,p=h*f,y=i*M,P=i*s,S=i*f,O=r[0],E=r[1],I=r[2],L=o[0],N=o[1],R=o[2],x=(1-(v+p))*O,d=(b+S)*O,g=(l-P)*O,A=(b-S)*E,Y=(1-(c+p))*E,T=(m+y)*E,w=(l+P)*I,_=(m-y)*I,q=(1-(c+v))*I;return t[0]=x,t[1]=d,t[2]=g,t[3]=0,t[4]=A,t[5]=Y,t[6]=T,t[7]=0,t[8]=w,t[9]=_,t[10]=q,t[11]=0,t[12]=n[0]+L-(x*L+A*N+w*R),t[13]=n[1]+N-(d*L+Y*N+_*R),t[14]=n[2]+R-(g*L+T*N+q*R),t[15]=1,t},n.fromQuat=function(t,a){var n=a[0],r=a[1],o=a[2],e=a[3],u=n+n,h=r+r,i=o+o,M=n*u,s=r*u,f=r*h,c=o*u,b=o*h,l=o*i,v=e*u,m=e*h,p=e*i;return t[0]=1-f-l,t[1]=s+p,t[2]=c-m,t[3]=0,t[4]=s-p,t[5]=1-M-l,t[6]=b+v,t[7]=0,t[8]=c+m,t[9]=b-v,t[10]=1-M-f,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.frustum=function(t,a,n,r,o,e,u){var h=1/(n-a),i=1/(o-r),M=1/(e-u);return t[0]=2*e*h,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*e*i,t[6]=0,t[7]=0,t[8]=(n+a)*h,t[9]=(o+r)*i,t[10]=(u+e)*M,t[11]=-1,t[12]=0,t[13]=0,t[14]=u*e*2*M,t[15]=0,t},n.perspective=function(t,a,n,r,o){var e,u=1/Math.tan(a/2);t[0]=u/n,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=o&&o!==1/0?(e=1/(r-o),t[10]=(o+r)*e,t[14]=2*o*r*e):(t[10]=-1,t[14]=-2*r);return t},n.perspectiveFromFieldOfView=function(t,a,n,r){var o=Math.tan(a.upDegrees*Math.PI/180),e=Math.tan(a.downDegrees*Math.PI/180),u=Math.tan(a.leftDegrees*Math.PI/180),h=Math.tan(a.rightDegrees*Math.PI/180),i=2/(u+h),M=2/(o+e);return t[0]=i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=M,t[6]=0,t[7]=0,t[8]=-(u-h)*i*.5,t[9]=(o-e)*M*.5,t[10]=r/(n-r),t[11]=-1,t[12]=0,t[13]=0,t[14]=r*n/(n-r),t[15]=0,t},n.ortho=function(t,a,n,r,o,e,u){var h=1/(a-n),i=1/(r-o),M=1/(e-u);return t[0]=-2*h,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*i,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*M,t[11]=0,t[12]=(a+n)*h,t[13]=(o+r)*i,t[14]=(u+e)*M,t[15]=1,t},n.lookAt=function(t,a,n,r){var e,h,i,M,s,f,c,b,l,v,m=a[0],p=a[1],y=a[2],P=r[0],S=r[1],O=r[2],E=n[0],I=n[1],L=n[2];if(Math.abs(m-E)<o.EPSILON&&Math.abs(p-I)<o.EPSILON&&Math.abs(y-L)<o.EPSILON)return u(t);c=m-E,b=p-I,l=y-L,v=1/Math.hypot(c,b,l),e=S*(l*=v)-O*(b*=v),h=O*(c*=v)-P*l,i=P*b-S*c,(v=Math.hypot(e,h,i))?(e*=v=1/v,h*=v,i*=v):(e=0,h=0,i=0);M=b*i-l*h,s=l*e-c*i,f=c*h-b*e,(v=Math.hypot(M,s,f))?(M*=v=1/v,s*=v,f*=v):(M=0,s=0,f=0);return t[0]=e,t[1]=M,t[2]=c,t[3]=0,t[4]=h,t[5]=s,t[6]=b,t[7]=0,t[8]=i,t[9]=f,t[10]=l,t[11]=0,t[12]=-(e*m+h*p+i*y),t[13]=-(M*m+s*p+f*y),t[14]=-(c*m+b*p+l*y),t[15]=1,t},n.targetTo=function(t,a,n,r){var o=a[0],e=a[1],u=a[2],h=r[0],i=r[1],M=r[2],s=o-n[0],f=e-n[1],c=u-n[2],b=s*s+f*f+c*c;b>0&&(b=1/Math.sqrt(b),s*=b,f*=b,c*=b);var l=i*c-M*f,v=M*s-h*c,m=h*f-i*s;(b=l*l+v*v+m*m)>0&&(b=1/Math.sqrt(b),l*=b,v*=b,m*=b);return t[0]=l,t[1]=v,t[2]=m,t[3]=0,t[4]=f*m-c*v,t[5]=c*l-s*m,t[6]=s*v-f*l,t[7]=0,t[8]=s,t[9]=f,t[10]=c,t[11]=0,t[12]=o,t[13]=e,t[14]=u,t[15]=1,t},n.str=function(t){return"mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},n.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},n.add=function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t[8]=a[8]+n[8],t[9]=a[9]+n[9],t[10]=a[10]+n[10],t[11]=a[11]+n[11],t[12]=a[12]+n[12],t[13]=a[13]+n[13],t[14]=a[14]+n[14],t[15]=a[15]+n[15],t},n.subtract=s,n.multiplyScalar=function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t[8]=a[8]*n,t[9]=a[9]*n,t[10]=a[10]*n,t[11]=a[11]*n,t[12]=a[12]*n,t[13]=a[13]*n,t[14]=a[14]*n,t[15]=a[15]*n,t},n.multiplyScalarAndAdd=function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t[6]=a[6]+n[6]*r,t[7]=a[7]+n[7]*r,t[8]=a[8]+n[8]*r,t[9]=a[9]+n[9]*r,t[10]=a[10]+n[10]*r,t[11]=a[11]+n[11]*r,t[12]=a[12]+n[12]*r,t[13]=a[13]+n[13]*r,t[14]=a[14]+n[14]*r,t[15]=a[15]+n[15]*r,t},n.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]&&t[9]===a[9]&&t[10]===a[10]&&t[11]===a[11]&&t[12]===a[12]&&t[13]===a[13]&&t[14]===a[14]&&t[15]===a[15]},n.equals=function(t,a){var n=t[0],r=t[1],e=t[2],u=t[3],h=t[4],i=t[5],M=t[6],s=t[7],f=t[8],c=t[9],b=t[10],l=t[11],v=t[12],m=t[13],p=t[14],y=t[15],P=a[0],S=a[1],O=a[2],E=a[3],I=a[4],L=a[5],N=a[6],R=a[7],x=a[8],d=a[9],g=a[10],A=a[11],Y=a[12],T=a[13],w=a[14],_=a[15];return Math.abs(n-P)<=o.EPSILON*Math.max(1,Math.abs(n),Math.abs(P))&&Math.abs(r-S)<=o.EPSILON*Math.max(1,Math.abs(r),Math.abs(S))&&Math.abs(e-O)<=o.EPSILON*Math.max(1,Math.abs(e),Math.abs(O))&&Math.abs(u-E)<=o.EPSILON*Math.max(1,Math.abs(u),Math.abs(E))&&Math.abs(h-I)<=o.EPSILON*Math.max(1,Math.abs(h),Math.abs(I))&&Math.abs(i-L)<=o.EPSILON*Math.max(1,Math.abs(i),Math.abs(L))&&Math.abs(M-N)<=o.EPSILON*Math.max(1,Math.abs(M),Math.abs(N))&&Math.abs(s-R)<=o.EPSILON*Math.max(1,Math.abs(s),Math.abs(R))&&Math.abs(f-x)<=o.EPSILON*Math.max(1,Math.abs(f),Math.abs(x))&&Math.abs(c-d)<=o.EPSILON*Math.max(1,Math.abs(c),Math.abs(d))&&Math.abs(b-g)<=o.EPSILON*Math.max(1,Math.abs(b),Math.abs(g))&&Math.abs(l-A)<=o.EPSILON*Math.max(1,Math.abs(l),Math.abs(A))&&Math.abs(v-Y)<=o.EPSILON*Math.max(1,Math.abs(v),Math.abs(Y))&&Math.abs(m-T)<=o.EPSILON*Math.max(1,Math.abs(m),Math.abs(T))&&Math.abs(p-w)<=o.EPSILON*Math.max(1,Math.abs(p),Math.abs(w))&&Math.abs(y-_)<=o.EPSILON*Math.max(1,Math.abs(y),Math.abs(_))},n.sub=n.mul=void 0;var o=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==r(t)&&"function"!=typeof t)return{default:t};var a=e();if(a&&a.has(t))return a.get(t);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var u in t)if(Object.prototype.hasOwnProperty.call(t,u)){var h=o?Object.getOwnPropertyDescriptor(t,u):null;h&&(h.get||h.set)?Object.defineProperty(n,u,h):n[u]=t[u]}n.default=t,a&&a.set(t,n);return n}(t("c6b4e451bc"));function e(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return e=function(){return t},t}function u(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function h(t,a,n){var r=a[0],o=a[1],e=a[2],u=a[3],h=a[4],i=a[5],M=a[6],s=a[7],f=a[8],c=a[9],b=a[10],l=a[11],v=a[12],m=a[13],p=a[14],y=a[15],P=n[0],S=n[1],O=n[2],E=n[3];return t[0]=P*r+S*h+O*f+E*v,t[1]=P*o+S*i+O*c+E*m,t[2]=P*e+S*M+O*b+E*p,t[3]=P*u+S*s+O*l+E*y,P=n[4],S=n[5],O=n[6],E=n[7],t[4]=P*r+S*h+O*f+E*v,t[5]=P*o+S*i+O*c+E*m,t[6]=P*e+S*M+O*b+E*p,t[7]=P*u+S*s+O*l+E*y,P=n[8],S=n[9],O=n[10],E=n[11],t[8]=P*r+S*h+O*f+E*v,t[9]=P*o+S*i+O*c+E*m,t[10]=P*e+S*M+O*b+E*p,t[11]=P*u+S*s+O*l+E*y,P=n[12],S=n[13],O=n[14],E=n[15],t[12]=P*r+S*h+O*f+E*v,t[13]=P*o+S*i+O*c+E*m,t[14]=P*e+S*M+O*b+E*p,t[15]=P*u+S*s+O*l+E*y,t}function i(t,a,n){var r=a[0],o=a[1],e=a[2],u=a[3],h=r+r,i=o+o,M=e+e,s=r*h,f=r*i,c=r*M,b=o*i,l=o*M,v=e*M,m=u*h,p=u*i,y=u*M;return t[0]=1-(b+v),t[1]=f+y,t[2]=c-p,t[3]=0,t[4]=f-y,t[5]=1-(s+v),t[6]=l+m,t[7]=0,t[8]=c+p,t[9]=l-m,t[10]=1-(s+b),t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t}function M(t,a){var n=a[0],r=a[1],o=a[2],e=a[4],u=a[5],h=a[6],i=a[8],M=a[9],s=a[10];return t[0]=Math.hypot(n,r,o),t[1]=Math.hypot(e,u,h),t[2]=Math.hypot(i,M,s),t}function s(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t[6]=a[6]-n[6],t[7]=a[7]-n[7],t[8]=a[8]-n[8],t[9]=a[9]-n[9],t[10]=a[10]-n[10],t[11]=a[11]-n[11],t[12]=a[12]-n[12],t[13]=a[13]-n[13],t[14]=a[14]-n[14],t[15]=a[15]-n[15],t}var f=h;n.mul=f;var c=s;n.sub=c},
"8b81ae2f8b": function _(t,r,n){function e(t){return(e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}n.create=l,n.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},n.setAxisAngle=f,n.getAxisAngle=function(t,r){var n=2*Math.acos(r[3]),e=Math.sin(n/2);e>a.EPSILON?(t[0]=r[0]/e,t[1]=r[1]/e,t[2]=r[2]/e):(t[0]=1,t[1]=0,t[2]=0);return n},n.getAngle=function(t,r){var n=O(t,r);return Math.acos(2*n*n-1)},n.multiply=h,n.rotateX=function(t,r,n){n*=.5;var e=r[0],a=r[1],o=r[2],u=r[3],s=Math.sin(n),c=Math.cos(n);return t[0]=e*c+u*s,t[1]=a*c+o*s,t[2]=o*c-a*s,t[3]=u*c-e*s,t},n.rotateY=function(t,r,n){n*=.5;var e=r[0],a=r[1],o=r[2],u=r[3],s=Math.sin(n),c=Math.cos(n);return t[0]=e*c-o*s,t[1]=a*c+u*s,t[2]=o*c+e*s,t[3]=u*c-a*s,t},n.rotateZ=function(t,r,n){n*=.5;var e=r[0],a=r[1],o=r[2],u=r[3],s=Math.sin(n),c=Math.cos(n);return t[0]=e*c+a*s,t[1]=a*c-e*s,t[2]=o*c+u*s,t[3]=u*c-o*s,t},n.calculateW=function(t,r){var n=r[0],e=r[1],a=r[2];return t[0]=n,t[1]=e,t[2]=a,t[3]=Math.sqrt(Math.abs(1-n*n-e*e-a*a)),t},n.exp=M,n.ln=v,n.pow=function(t,r,n){return v(t,r),P(t,t,n),M(t,t),t},n.slerp=p,n.random=function(t){var r=a.RANDOM(),n=a.RANDOM(),e=a.RANDOM(),o=Math.sqrt(1-r),u=Math.sqrt(r);return t[0]=o*Math.sin(2*Math.PI*n),t[1]=o*Math.cos(2*Math.PI*n),t[2]=u*Math.sin(2*Math.PI*e),t[3]=u*Math.cos(2*Math.PI*e),t},n.invert=function(t,r){var n=r[0],e=r[1],a=r[2],o=r[3],u=n*n+e*e+a*a+o*o,s=u?1/u:0;return t[0]=-n*s,t[1]=-e*s,t[2]=-a*s,t[3]=o*s,t},n.conjugate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t[3]=r[3],t},n.fromMat3=y,n.fromEuler=function(t,r,n,e){var a=.5*Math.PI/180;r*=a,n*=a,e*=a;var o=Math.sin(r),u=Math.cos(r),s=Math.sin(n),c=Math.cos(n),i=Math.sin(e),l=Math.cos(e);return t[0]=o*c*l-u*s*i,t[1]=u*s*l+o*c*i,t[2]=u*c*i-o*s*l,t[3]=u*c*l+o*s*i,t},n.str=function(t){return"quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},n.setAxes=n.sqlerp=n.rotationTo=n.equals=n.exactEquals=n.normalize=n.sqrLen=n.squaredLength=n.len=n.length=n.lerp=n.dot=n.scale=n.mul=n.add=n.set=n.copy=n.fromValues=n.clone=void 0;var a=i(t("c6b4e451bc")),o=i(t("4dc492e8e1")),u=i(t("2e13827733")),s=i(t("03254e8a21"));function c(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return c=function(){return t},t}function i(t){if(t&&t.__esModule)return t;if(null===t||"object"!==e(t)&&"function"!=typeof t)return{default:t};var r=c();if(r&&r.has(t))return r.get(t);var n={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var u=a?Object.getOwnPropertyDescriptor(t,o):null;u&&(u.get||u.set)?Object.defineProperty(n,o,u):n[o]=t[o]}return n.default=t,r&&r.set(t,n),n}function l(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function f(t,r,n){n*=.5;var e=Math.sin(n);return t[0]=e*r[0],t[1]=e*r[1],t[2]=e*r[2],t[3]=Math.cos(n),t}function h(t,r,n){var e=r[0],a=r[1],o=r[2],u=r[3],s=n[0],c=n[1],i=n[2],l=n[3];return t[0]=e*l+u*s+a*i-o*c,t[1]=a*l+u*c+o*s-e*i,t[2]=o*l+u*i+e*c-a*s,t[3]=u*l-e*s-a*c-o*i,t}function M(t,r){var n=r[0],e=r[1],a=r[2],o=r[3],u=Math.sqrt(n*n+e*e+a*a),s=Math.exp(o),c=u>0?s*Math.sin(u)/u:0;return t[0]=n*c,t[1]=e*c,t[2]=a*c,t[3]=s*Math.cos(u),t}function v(t,r){var n=r[0],e=r[1],a=r[2],o=r[3],u=Math.sqrt(n*n+e*e+a*a),s=u>0?Math.atan2(u,o)/u:0;return t[0]=n*s,t[1]=e*s,t[2]=a*s,t[3]=.5*Math.log(n*n+e*e+a*a+o*o),t}function p(t,r,n,e){var o,u,s,c,i,l=r[0],f=r[1],h=r[2],M=r[3],v=n[0],p=n[1],y=n[2],d=n[3];return(u=l*v+f*p+h*y+M*d)<0&&(u=-u,v=-v,p=-p,y=-y,d=-d),1-u>a.EPSILON?(o=Math.acos(u),s=Math.sin(o),c=Math.sin((1-e)*o)/s,i=Math.sin(e*o)/s):(c=1-e,i=e),t[0]=c*l+i*v,t[1]=c*f+i*p,t[2]=c*h+i*y,t[3]=c*M+i*d,t}function y(t,r){var n,e=r[0]+r[4]+r[8];if(e>0)n=Math.sqrt(e+1),t[3]=.5*n,n=.5/n,t[0]=(r[5]-r[7])*n,t[1]=(r[6]-r[2])*n,t[2]=(r[1]-r[3])*n;else{var a=0;r[4]>r[0]&&(a=1),r[8]>r[3*a+a]&&(a=2);var o=(a+1)%3,u=(a+2)%3;n=Math.sqrt(r[3*a+a]-r[3*o+o]-r[3*u+u]+1),t[a]=.5*n,n=.5/n,t[3]=(r[3*o+u]-r[3*u+o])*n,t[o]=(r[3*o+a]+r[3*a+o])*n,t[u]=(r[3*u+a]+r[3*a+u])*n}return t}var d=s.clone;n.clone=d;var m=s.fromValues;n.fromValues=m;var q=s.copy;n.copy=q;var g=s.set;n.set=g;var b=s.add;n.add=b;var A=h;n.mul=A;var P=s.scale;n.scale=P;var O=s.dot;n.dot=O;var x=s.lerp;n.lerp=x;var E=s.length;n.length=E;var I=E;n.len=I;var j=s.squaredLength;n.squaredLength=j;var L=j;n.sqrLen=L;var R=s.normalize;n.normalize=R;var S=s.exactEquals;n.exactEquals=S;var w=s.equals;n.equals=w;var D,N,V,Y=(D=u.create(),N=u.fromValues(1,0,0),V=u.fromValues(0,1,0),function(t,r,n){var e=u.dot(r,n);return e<-.999999?(u.cross(D,N,r),u.len(D)<1e-6&&u.cross(D,V,r),u.normalize(D,D),f(t,D,Math.PI),t):e>.999999?(t[0]=0,t[1]=0,t[2]=0,t[3]=1,t):(u.cross(D,r,n),t[0]=D[0],t[1]=D[1],t[2]=D[2],t[3]=1+e,R(t,t))});n.rotationTo=Y;var _,z,T=(_=l(),z=l(),function(t,r,n,e,a,o){return p(_,r,a,o),p(z,n,e,o),p(t,_,z,2*o*(1-o)),t});n.sqlerp=T;var W,k=(W=o.create(),function(t,r,n,e){return W[0]=n[0],W[3]=n[1],W[6]=n[2],W[1]=e[0],W[4]=e[1],W[7]=e[2],W[2]=-r[0],W[5]=-r[1],W[8]=-r[2],R(t,y(t,W))});n.setAxes=k},
"2e13827733": function _(t,n,r){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=o,r.clone=function(t){var n=new e.ARRAY_TYPE(3);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n},r.length=i,r.fromValues=function(t,n,r){var a=new e.ARRAY_TYPE(3);return a[0]=t,a[1]=n,a[2]=r,a},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t},r.set=function(t,n,r,a){return t[0]=n,t[1]=r,t[2]=a,t},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t},r.subtract=c,r.multiply=f,r.divide=s,r.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t},r.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t},r.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t},r.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t},r.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t},r.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t},r.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t},r.distance=h,r.squaredDistance=M,r.squaredLength=l,r.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t},r.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t},r.normalize=function(t,n){var r=n[0],a=n[1],e=n[2],u=r*r+a*a+e*e;u>0&&(u=1/Math.sqrt(u));return t[0]=n[0]*u,t[1]=n[1]*u,t[2]=n[2]*u,t},r.dot=v,r.cross=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[0],i=r[1],c=r[2];return t[0]=e*c-u*i,t[1]=u*o-a*c,t[2]=a*i-e*o,t},r.lerp=function(t,n,r,a){var e=n[0],u=n[1],o=n[2];return t[0]=e+a*(r[0]-e),t[1]=u+a*(r[1]-u),t[2]=o+a*(r[2]-o),t},r.hermite=function(t,n,r,a,e,u){var o=u*u,i=o*(2*u-3)+1,c=o*(u-2)+u,f=o*(u-1),s=o*(3-2*u);return t[0]=n[0]*i+r[0]*c+a[0]*f+e[0]*s,t[1]=n[1]*i+r[1]*c+a[1]*f+e[1]*s,t[2]=n[2]*i+r[2]*c+a[2]*f+e[2]*s,t},r.bezier=function(t,n,r,a,e,u){var o=1-u,i=o*o,c=u*u,f=i*o,s=3*u*i,h=3*c*o,M=c*u;return t[0]=n[0]*f+r[0]*s+a[0]*h+e[0]*M,t[1]=n[1]*f+r[1]*s+a[1]*h+e[1]*M,t[2]=n[2]*f+r[2]*s+a[2]*h+e[2]*M,t},r.random=function(t,n){n=n||1;var r=2*e.RANDOM()*Math.PI,a=2*e.RANDOM()-1,u=Math.sqrt(1-a*a)*n;return t[0]=Math.cos(r)*u,t[1]=Math.sin(r)*u,t[2]=a*n,t},r.transformMat4=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[3]*a+r[7]*e+r[11]*u+r[15];return o=o||1,t[0]=(r[0]*a+r[4]*e+r[8]*u+r[12])/o,t[1]=(r[1]*a+r[5]*e+r[9]*u+r[13])/o,t[2]=(r[2]*a+r[6]*e+r[10]*u+r[14])/o,t},r.transformMat3=function(t,n,r){var a=n[0],e=n[1],u=n[2];return t[0]=a*r[0]+e*r[3]+u*r[6],t[1]=a*r[1]+e*r[4]+u*r[7],t[2]=a*r[2]+e*r[5]+u*r[8],t},r.transformQuat=function(t,n,r){var a=r[0],e=r[1],u=r[2],o=r[3],i=n[0],c=n[1],f=n[2],s=e*f-u*c,h=u*i-a*f,M=a*c-e*i,l=e*M-u*h,v=u*s-a*M,m=a*h-e*s,b=2*o;return s*=b,h*=b,M*=b,l*=2,v*=2,m*=2,t[0]=i+s+l,t[1]=c+h+v,t[2]=f+M+m,t},r.rotateX=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[0],u[1]=e[1]*Math.cos(a)-e[2]*Math.sin(a),u[2]=e[1]*Math.sin(a)+e[2]*Math.cos(a),t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},r.rotateY=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[2]*Math.sin(a)+e[0]*Math.cos(a),u[1]=e[1],u[2]=e[2]*Math.cos(a)-e[0]*Math.sin(a),t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},r.rotateZ=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[0]*Math.cos(a)-e[1]*Math.sin(a),u[1]=e[0]*Math.sin(a)+e[1]*Math.cos(a),u[2]=e[2],t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},r.angle=function(t,n){var r=t[0],a=t[1],e=t[2],u=n[0],o=n[1],i=n[2],c=Math.sqrt(r*r+a*a+e*e),f=Math.sqrt(u*u+o*o+i*i),s=c*f,h=s&&v(t,n)/s;return Math.acos(Math.min(Math.max(h,-1),1))},r.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t},r.str=function(t){return"vec3("+t[0]+", "+t[1]+", "+t[2]+")"},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]},r.equals=function(t,n){var r=t[0],a=t[1],u=t[2],o=n[0],i=n[1],c=n[2];return Math.abs(r-o)<=e.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(a-i)<=e.EPSILON*Math.max(1,Math.abs(a),Math.abs(i))&&Math.abs(u-c)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(c))},r.forEach=r.sqrLen=r.len=r.sqrDist=r.dist=r.div=r.mul=r.sub=void 0;var e=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var n=u();if(n&&n.has(t))return n.get(t);var r={},e=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=e?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function u(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return u=function(){return t},t}function o(){var t=new e.ARRAY_TYPE(3);return e.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function i(t){var n=t[0],r=t[1],a=t[2];return Math.hypot(n,r,a)}function c(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t}function f(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t}function s(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t}function h(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2];return Math.hypot(r,a,e)}function M(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2];return r*r+a*a+e*e}function l(t){var n=t[0],r=t[1],a=t[2];return n*n+r*r+a*a}function v(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]}var m=c;r.sub=m;var b=f;r.mul=b;var d=s;r.div=d;var y=h;r.dist=y;var p=M;r.sqrDist=p;var A=i;r.len=A;var O=l;r.sqrLen=O;var P,q=(P=o(),function(t,n,r,a,e,u){var o,i;for(n||(n=3),r||(r=0),i=a?Math.min(a*n+r,t.length):t.length,o=r;o<i;o+=n)P[0]=t[o],P[1]=t[o+1],P[2]=t[o+2],e(P,P,u),t[o]=P[0],t[o+1]=P[1],t[o+2]=P[2];return t});r.forEach=q},
"03254e8a21": function _(t,n,r){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=o,r.clone=function(t){var n=new e.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},r.fromValues=function(t,n,r,a){var u=new e.ARRAY_TYPE(4);return u[0]=t,u[1]=n,u[2]=r,u[3]=a,u},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},r.set=function(t,n,r,a,e){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},r.subtract=i,r.multiply=c,r.divide=f,r.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t[3]=Math.ceil(n[3]),t},r.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t[3]=Math.floor(n[3]),t},r.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t[3]=Math.min(n[3],r[3]),t},r.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t[3]=Math.max(n[3],r[3]),t},r.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t[3]=Math.round(n[3]),t},r.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},r.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t},r.distance=h,r.squaredDistance=s,r.length=M,r.squaredLength=l,r.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t[3]=-n[3],t},r.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t[3]=1/n[3],t},r.normalize=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r*r+a*a+e*e+u*u;o>0&&(o=1/Math.sqrt(o));return t[0]=r*o,t[1]=a*o,t[2]=e*o,t[3]=u*o,t},r.dot=function(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]+t[3]*n[3]},r.cross=function(t,n,r,a){var e=r[0]*a[1]-r[1]*a[0],u=r[0]*a[2]-r[2]*a[0],o=r[0]*a[3]-r[3]*a[0],i=r[1]*a[2]-r[2]*a[1],c=r[1]*a[3]-r[3]*a[1],f=r[2]*a[3]-r[3]*a[2],h=n[0],s=n[1],M=n[2],l=n[3];return t[0]=s*f-M*c+l*i,t[1]=-h*f+M*o-l*u,t[2]=h*c-s*o+l*e,t[3]=-h*i+s*u-M*e,t},r.lerp=function(t,n,r,a){var e=n[0],u=n[1],o=n[2],i=n[3];return t[0]=e+a*(r[0]-e),t[1]=u+a*(r[1]-u),t[2]=o+a*(r[2]-o),t[3]=i+a*(r[3]-i),t},r.random=function(t,n){var r,a,u,o,i,c;n=n||1;do{r=2*e.RANDOM()-1,a=2*e.RANDOM()-1,i=r*r+a*a}while(i>=1);do{u=2*e.RANDOM()-1,o=2*e.RANDOM()-1,c=u*u+o*o}while(c>=1);var f=Math.sqrt((1-i)/c);return t[0]=n*r,t[1]=n*a,t[2]=n*u*f,t[3]=n*o*f,t},r.transformMat4=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3];return t[0]=r[0]*a+r[4]*e+r[8]*u+r[12]*o,t[1]=r[1]*a+r[5]*e+r[9]*u+r[13]*o,t[2]=r[2]*a+r[6]*e+r[10]*u+r[14]*o,t[3]=r[3]*a+r[7]*e+r[11]*u+r[15]*o,t},r.transformQuat=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[0],i=r[1],c=r[2],f=r[3],h=f*a+i*u-c*e,s=f*e+c*a-o*u,M=f*u+o*e-i*a,l=-o*a-i*e-c*u;return t[0]=h*f+l*-o+s*-c-M*-i,t[1]=s*f+l*-i+M*-o-h*-c,t[2]=M*f+l*-c+h*-i-s*-o,t[3]=n[3],t},r.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},r.str=function(t){return"vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},r.equals=function(t,n){var r=t[0],a=t[1],u=t[2],o=t[3],i=n[0],c=n[1],f=n[2],h=n[3];return Math.abs(r-i)<=e.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(a-c)<=e.EPSILON*Math.max(1,Math.abs(a),Math.abs(c))&&Math.abs(u-f)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(f))&&Math.abs(o-h)<=e.EPSILON*Math.max(1,Math.abs(o),Math.abs(h))},r.forEach=r.sqrLen=r.len=r.sqrDist=r.dist=r.div=r.mul=r.sub=void 0;var e=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var n=u();if(n&&n.has(t))return n.get(t);var r={},e=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=e?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function u(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return u=function(){return t},t}function o(){var t=new e.ARRAY_TYPE(4);return e.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}function c(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t[3]=n[3]*r[3],t}function f(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t[3]=n[3]/r[3],t}function h(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2],u=n[3]-t[3];return Math.hypot(r,a,e,u)}function s(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2],u=n[3]-t[3];return r*r+a*a+e*e+u*u}function M(t){var n=t[0],r=t[1],a=t[2],e=t[3];return Math.hypot(n,r,a,e)}function l(t){var n=t[0],r=t[1],a=t[2],e=t[3];return n*n+r*r+a*a+e*e}var v=i;r.sub=v;var b=c;r.mul=b;var m=f;r.div=m;var d=h;r.dist=d;var y=s;r.sqrDist=y;var p=M;r.len=p;var O=l;r.sqrLen=O;var A,P=(A=o(),function(t,n,r,a,e,u){var o,i;for(n||(n=4),r||(r=0),i=a?Math.min(a*n+r,t.length):t.length,o=r;o<i;o+=n)A[0]=t[o],A[1]=t[o+1],A[2]=t[o+2],A[3]=t[o+3],e(A,A,u),t[o]=A[0],t[o+1]=A[1],t[o+2]=A[2],t[o+3]=A[3];return t});r.forEach=P},
"27670309ba": function _(t,r,n){function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}n.create=function(){var t=new e.ARRAY_TYPE(8);e.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0);return t[3]=1,t},n.clone=function(t){var r=new e.ARRAY_TYPE(8);return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r},n.fromValues=function(t,r,n,a,o,u,i,f){var c=new e.ARRAY_TYPE(8);return c[0]=t,c[1]=r,c[2]=n,c[3]=a,c[4]=o,c[5]=u,c[6]=i,c[7]=f,c},n.fromRotationTranslationValues=function(t,r,n,a,o,u,i){var f=new e.ARRAY_TYPE(8);f[0]=t,f[1]=r,f[2]=n,f[3]=a;var c=.5*o,s=.5*u,l=.5*i;return f[4]=c*a+s*n-l*r,f[5]=s*a+l*t-c*n,f[6]=l*a+c*r-s*t,f[7]=-c*t-s*r-l*n,f},n.fromRotationTranslation=c,n.fromTranslation=function(t,r){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*r[0],t[5]=.5*r[1],t[6]=.5*r[2],t[7]=0,t},n.fromRotation=function(t,r){return t[0]=r[0],t[1]=r[1],t[2]=r[2],t[3]=r[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.fromMat4=function(t,r){var n=o.create();u.getRotation(n,r);var a=new e.ARRAY_TYPE(3);return u.getTranslation(a,r),c(t,n,a),t},n.copy=s,n.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.set=function(t,r,n,a,e,o,u,i,f){return t[0]=r,t[1]=n,t[2]=a,t[3]=e,t[4]=o,t[5]=u,t[6]=i,t[7]=f,t},n.getDual=function(t,r){return t[0]=r[4],t[1]=r[5],t[2]=r[6],t[3]=r[7],t},n.setDual=function(t,r){return t[4]=r[0],t[5]=r[1],t[6]=r[2],t[7]=r[3],t},n.getTranslation=function(t,r){var n=r[4],a=r[5],e=r[6],o=r[7],u=-r[0],i=-r[1],f=-r[2],c=r[3];return t[0]=2*(n*c+o*u+a*f-e*i),t[1]=2*(a*c+o*i+e*u-n*f),t[2]=2*(e*c+o*f+n*i-a*u),t},n.translate=function(t,r,n){var a=r[0],e=r[1],o=r[2],u=r[3],i=.5*n[0],f=.5*n[1],c=.5*n[2],s=r[4],l=r[5],h=r[6],b=r[7];return t[0]=a,t[1]=e,t[2]=o,t[3]=u,t[4]=u*i+e*c-o*f+s,t[5]=u*f+o*i-a*c+l,t[6]=u*c+a*f-e*i+h,t[7]=-a*i-e*f-o*c+b,t},n.rotateX=function(t,r,n){var a=-r[0],e=-r[1],u=-r[2],i=r[3],f=r[4],c=r[5],s=r[6],l=r[7],h=f*i+l*a+c*u-s*e,b=c*i+l*e+s*a-f*u,M=s*i+l*u+f*e-c*a,v=l*i-f*a-c*e-s*u;return o.rotateX(t,r,n),a=t[0],e=t[1],u=t[2],i=t[3],t[4]=h*i+v*a+b*u-M*e,t[5]=b*i+v*e+M*a-h*u,t[6]=M*i+v*u+h*e-b*a,t[7]=v*i-h*a-b*e-M*u,t},n.rotateY=function(t,r,n){var a=-r[0],e=-r[1],u=-r[2],i=r[3],f=r[4],c=r[5],s=r[6],l=r[7],h=f*i+l*a+c*u-s*e,b=c*i+l*e+s*a-f*u,M=s*i+l*u+f*e-c*a,v=l*i-f*a-c*e-s*u;return o.rotateY(t,r,n),a=t[0],e=t[1],u=t[2],i=t[3],t[4]=h*i+v*a+b*u-M*e,t[5]=b*i+v*e+M*a-h*u,t[6]=M*i+v*u+h*e-b*a,t[7]=v*i-h*a-b*e-M*u,t},n.rotateZ=function(t,r,n){var a=-r[0],e=-r[1],u=-r[2],i=r[3],f=r[4],c=r[5],s=r[6],l=r[7],h=f*i+l*a+c*u-s*e,b=c*i+l*e+s*a-f*u,M=s*i+l*u+f*e-c*a,v=l*i-f*a-c*e-s*u;return o.rotateZ(t,r,n),a=t[0],e=t[1],u=t[2],i=t[3],t[4]=h*i+v*a+b*u-M*e,t[5]=b*i+v*e+M*a-h*u,t[6]=M*i+v*u+h*e-b*a,t[7]=v*i-h*a-b*e-M*u,t},n.rotateByQuatAppend=function(t,r,n){var a=n[0],e=n[1],o=n[2],u=n[3],i=r[0],f=r[1],c=r[2],s=r[3];return t[0]=i*u+s*a+f*o-c*e,t[1]=f*u+s*e+c*a-i*o,t[2]=c*u+s*o+i*e-f*a,t[3]=s*u-i*a-f*e-c*o,i=r[4],f=r[5],c=r[6],s=r[7],t[4]=i*u+s*a+f*o-c*e,t[5]=f*u+s*e+c*a-i*o,t[6]=c*u+s*o+i*e-f*a,t[7]=s*u-i*a-f*e-c*o,t},n.rotateByQuatPrepend=function(t,r,n){var a=r[0],e=r[1],o=r[2],u=r[3],i=n[0],f=n[1],c=n[2],s=n[3];return t[0]=a*s+u*i+e*c-o*f,t[1]=e*s+u*f+o*i-a*c,t[2]=o*s+u*c+a*f-e*i,t[3]=u*s-a*i-e*f-o*c,i=n[4],f=n[5],c=n[6],s=n[7],t[4]=a*s+u*i+e*c-o*f,t[5]=e*s+u*f+o*i-a*c,t[6]=o*s+u*c+a*f-e*i,t[7]=u*s-a*i-e*f-o*c,t},n.rotateAroundAxis=function(t,r,n,a){if(Math.abs(a)<e.EPSILON)return s(t,r);var o=Math.hypot(n[0],n[1],n[2]);a*=.5;var u=Math.sin(a),i=u*n[0]/o,f=u*n[1]/o,c=u*n[2]/o,l=Math.cos(a),h=r[0],b=r[1],M=r[2],v=r[3];t[0]=h*l+v*i+b*c-M*f,t[1]=b*l+v*f+M*i-h*c,t[2]=M*l+v*c+h*f-b*i,t[3]=v*l-h*i-b*f-M*c;var y=r[4],p=r[5],m=r[6],P=r[7];return t[4]=y*l+P*i+p*c-m*f,t[5]=p*l+P*f+m*i-y*c,t[6]=m*l+P*c+y*f-p*i,t[7]=P*l-y*i-p*f-m*c,t},n.add=function(t,r,n){return t[0]=r[0]+n[0],t[1]=r[1]+n[1],t[2]=r[2]+n[2],t[3]=r[3]+n[3],t[4]=r[4]+n[4],t[5]=r[5]+n[5],t[6]=r[6]+n[6],t[7]=r[7]+n[7],t},n.multiply=b,n.scale=function(t,r,n){return t[0]=r[0]*n,t[1]=r[1]*n,t[2]=r[2]*n,t[3]=r[3]*n,t[4]=r[4]*n,t[5]=r[5]*n,t[6]=r[6]*n,t[7]=r[7]*n,t},n.lerp=function(t,r,n,a){var e=1-a;v(r,n)<0&&(a=-a);return t[0]=r[0]*e+n[0]*a,t[1]=r[1]*e+n[1]*a,t[2]=r[2]*e+n[2]*a,t[3]=r[3]*e+n[3]*a,t[4]=r[4]*e+n[4]*a,t[5]=r[5]*e+n[5]*a,t[6]=r[6]*e+n[6]*a,t[7]=r[7]*e+n[7]*a,t},n.invert=function(t,r){var n=m(r);return t[0]=-r[0]/n,t[1]=-r[1]/n,t[2]=-r[2]/n,t[3]=r[3]/n,t[4]=-r[4]/n,t[5]=-r[5]/n,t[6]=-r[6]/n,t[7]=r[7]/n,t},n.conjugate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t[3]=r[3],t[4]=-r[4],t[5]=-r[5],t[6]=-r[6],t[7]=r[7],t},n.normalize=function(t,r){var n=m(r);if(n>0){n=Math.sqrt(n);var a=r[0]/n,e=r[1]/n,o=r[2]/n,u=r[3]/n,i=r[4],f=r[5],c=r[6],s=r[7],l=a*i+e*f+o*c+u*s;t[0]=a,t[1]=e,t[2]=o,t[3]=u,t[4]=(i-a*l)/n,t[5]=(f-e*l)/n,t[6]=(c-o*l)/n,t[7]=(s-u*l)/n}return t},n.str=function(t){return"quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},n.exactEquals=function(t,r){return t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]&&t[3]===r[3]&&t[4]===r[4]&&t[5]===r[5]&&t[6]===r[6]&&t[7]===r[7]},n.equals=function(t,r){var n=t[0],a=t[1],o=t[2],u=t[3],i=t[4],f=t[5],c=t[6],s=t[7],l=r[0],h=r[1],b=r[2],M=r[3],v=r[4],y=r[5],p=r[6],m=r[7];return Math.abs(n-l)<=e.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))&&Math.abs(a-h)<=e.EPSILON*Math.max(1,Math.abs(a),Math.abs(h))&&Math.abs(o-b)<=e.EPSILON*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(u-M)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(M))&&Math.abs(i-v)<=e.EPSILON*Math.max(1,Math.abs(i),Math.abs(v))&&Math.abs(f-y)<=e.EPSILON*Math.max(1,Math.abs(f),Math.abs(y))&&Math.abs(c-p)<=e.EPSILON*Math.max(1,Math.abs(c),Math.abs(p))&&Math.abs(s-m)<=e.EPSILON*Math.max(1,Math.abs(s),Math.abs(m))},n.sqrLen=n.squaredLength=n.len=n.length=n.dot=n.mul=n.setReal=n.getReal=void 0;var e=f(t("c6b4e451bc")),o=f(t("8b81ae2f8b")),u=f(t("948401a902"));function i(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return i=function(){return t},t}function f(t){if(t&&t.__esModule)return t;if(null===t||"object"!==a(t)&&"function"!=typeof t)return{default:t};var r=i();if(r&&r.has(t))return r.get(t);var n={},e=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var u=e?Object.getOwnPropertyDescriptor(t,o):null;u&&(u.get||u.set)?Object.defineProperty(n,o,u):n[o]=t[o]}return n.default=t,r&&r.set(t,n),n}function c(t,r,n){var a=.5*n[0],e=.5*n[1],o=.5*n[2],u=r[0],i=r[1],f=r[2],c=r[3];return t[0]=u,t[1]=i,t[2]=f,t[3]=c,t[4]=a*c+e*f-o*i,t[5]=e*c+o*u-a*f,t[6]=o*c+a*i-e*u,t[7]=-a*u-e*i-o*f,t}function s(t,r){return t[0]=r[0],t[1]=r[1],t[2]=r[2],t[3]=r[3],t[4]=r[4],t[5]=r[5],t[6]=r[6],t[7]=r[7],t}var l=o.copy;n.getReal=l;var h=o.copy;function b(t,r,n){var a=r[0],e=r[1],o=r[2],u=r[3],i=n[4],f=n[5],c=n[6],s=n[7],l=r[4],h=r[5],b=r[6],M=r[7],v=n[0],y=n[1],p=n[2],m=n[3];return t[0]=a*m+u*v+e*p-o*y,t[1]=e*m+u*y+o*v-a*p,t[2]=o*m+u*p+a*y-e*v,t[3]=u*m-a*v-e*y-o*p,t[4]=a*s+u*i+e*c-o*f+l*m+M*v+h*p-b*y,t[5]=e*s+u*f+o*i-a*c+h*m+M*y+b*v-l*p,t[6]=o*s+u*c+a*f-e*i+b*m+M*p+l*y-h*v,t[7]=u*s-a*i-e*f-o*c+M*m-l*v-h*y-b*p,t}n.setReal=h;var M=b;n.mul=M;var v=o.dot;n.dot=v;var y=o.length;n.length=y;var p=y;n.len=p;var m=o.squaredLength;n.squaredLength=m;var P=m;n.sqrLen=P},
"62ac52b540": function _(t,n,r){function e(t){return(e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}r.create=o,r.clone=function(t){var n=new a.ARRAY_TYPE(2);return n[0]=t[0],n[1]=t[1],n},r.fromValues=function(t,n){var r=new a.ARRAY_TYPE(2);return r[0]=t,r[1]=n,r},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t},r.set=function(t,n,r){return t[0]=n,t[1]=r,t},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t},r.subtract=i,r.multiply=c,r.divide=f,r.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t},r.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t},r.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t},r.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t},r.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t},r.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t},r.scaleAndAdd=function(t,n,r,e){return t[0]=n[0]+r[0]*e,t[1]=n[1]+r[1]*e,t},r.distance=s,r.squaredDistance=l,r.length=h,r.squaredLength=M,r.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t},r.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t},r.normalize=function(t,n){var r=n[0],e=n[1],a=r*r+e*e;a>0&&(a=1/Math.sqrt(a));return t[0]=n[0]*a,t[1]=n[1]*a,t},r.dot=function(t,n){return t[0]*n[0]+t[1]*n[1]},r.cross=function(t,n,r){var e=n[0]*r[1]-n[1]*r[0];return t[0]=t[1]=0,t[2]=e,t},r.lerp=function(t,n,r,e){var a=n[0],u=n[1];return t[0]=a+e*(r[0]-a),t[1]=u+e*(r[1]-u),t},r.random=function(t,n){n=n||1;var r=2*a.RANDOM()*Math.PI;return t[0]=Math.cos(r)*n,t[1]=Math.sin(r)*n,t},r.transformMat2=function(t,n,r){var e=n[0],a=n[1];return t[0]=r[0]*e+r[2]*a,t[1]=r[1]*e+r[3]*a,t},r.transformMat2d=function(t,n,r){var e=n[0],a=n[1];return t[0]=r[0]*e+r[2]*a+r[4],t[1]=r[1]*e+r[3]*a+r[5],t},r.transformMat3=function(t,n,r){var e=n[0],a=n[1];return t[0]=r[0]*e+r[3]*a+r[6],t[1]=r[1]*e+r[4]*a+r[7],t},r.transformMat4=function(t,n,r){var e=n[0],a=n[1];return t[0]=r[0]*e+r[4]*a+r[12],t[1]=r[1]*e+r[5]*a+r[13],t},r.rotate=function(t,n,r,e){var a=n[0]-r[0],u=n[1]-r[1],o=Math.sin(e),i=Math.cos(e);return t[0]=a*i-u*o+r[0],t[1]=a*o+u*i+r[1],t},r.angle=function(t,n){var r=t[0],e=t[1],a=n[0],u=n[1],o=Math.sqrt(r*r+e*e)*Math.sqrt(a*a+u*u),i=o&&(r*a+e*u)/o;return Math.acos(Math.min(Math.max(i,-1),1))},r.zero=function(t){return t[0]=0,t[1]=0,t},r.str=function(t){return"vec2("+t[0]+", "+t[1]+")"},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]},r.equals=function(t,n){var r=t[0],e=t[1],u=n[0],o=n[1];return Math.abs(r-u)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(u))&&Math.abs(e-o)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(o))},r.forEach=r.sqrLen=r.sqrDist=r.dist=r.div=r.mul=r.sub=r.len=void 0;var a=function(t){if(t&&t.__esModule)return t;if(null===t||"object"!==e(t)&&"function"!=typeof t)return{default:t};var n=u();if(n&&n.has(t))return n.get(t);var r={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if(Object.prototype.hasOwnProperty.call(t,o)){var i=a?Object.getOwnPropertyDescriptor(t,o):null;i&&(i.get||i.set)?Object.defineProperty(r,o,i):r[o]=t[o]}r.default=t,n&&n.set(t,r);return r}(t("c6b4e451bc"));function u(){if("function"!=typeof WeakMap)return null;var t=new WeakMap;return u=function(){return t},t}function o(){var t=new a.ARRAY_TYPE(2);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0),t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t}function c(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t}function f(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t}function s(t,n){var r=n[0]-t[0],e=n[1]-t[1];return Math.hypot(r,e)}function l(t,n){var r=n[0]-t[0],e=n[1]-t[1];return r*r+e*e}function h(t){var n=t[0],r=t[1];return Math.hypot(n,r)}function M(t){var n=t[0],r=t[1];return n*n+r*r}var v=h;r.len=v;var m=i;r.sub=m;var d=c;r.mul=d;var y=f;r.div=y;var p=s;r.dist=p;var b=l;r.sqrDist=b;var A=M;r.sqrLen=A;var P,q=(P=o(),function(t,n,r,e,a,u){var o,i;for(n||(n=2),r||(r=0),i=e?Math.min(e*n+r,t.length):t.length,o=r;o<i;o+=n)P[0]=t[o],P[1]=t[o+1],a(P,P,u),t[o]=P[0],t[o+1]=P[1];return t});r.forEach=q},
}, "aa4f566620", {"index":"aa4f566620","models/index":"4d02676c49","models/ace":"ff4b91e885","models/layout":"ec60963462","models/audio":"12e90a1b7e","models/deckgl":"cf3b018c7a","models/tooltips":"27d3545a25","models/html":"70a2bb70ef","models/json":"dac8d750fa","models/katex":"c81021c8fd","models/mathjax":"a93ded647d","models/player":"98100899bc","models/plotly":"d46f026c83","models/util":"62ba79515f","models/progress":"d9b3a262de","models/state":"4b4afba86a","models/vega":"14b669e6fc","models/video":"71a2bbec38","models/videostream":"76bc93d621","models/vtk/index":"63070bc9ce","models/vtk/vtk":"1a4b530306","models/vtk/vtk_layout":"7620c2cc05","models/vtk/vtk_utils":"3b847a648d","models/vtk/vtkvolume":"b933e81f56","models/vtk/vtkaxes":"5bc27423fe"}, {});
})

//# sourceMappingURL=panel.min.js.map
